'use strict';

/**
 * @ngdoc overview
 * @name app [smartadminApp]
 * @description
 * # app [smartadminApp]
 *
 * Main module of the application.
 */
define([
    'angular',
    'angular-couch-potato',
    'angular-ui-router',
    'angular-animate',
    'angular-bootstrap',
    'underscore',
    'smartwidgets',
    'notification',
    'angular-storage',
    'angular-sanitize',
    'jspdf',
    'autotable',
    'socket-io',
    'socket-io2',
    'socket-io4',
    'angularUtils.directives.dirPagination',
    'angular-desktop-notification',
    'cripto',
    'Store',
    'Xcmobx',
    'mobx-angularjs'
], function (ng, couchPotato) {
    var app = ng.module('app', [
        'ngXcmobx',
        'ngStore',
        'ngSanitize',
        'ngStorage',
        'scs.couch-potato',
        'ngAnimate',
        'ui.router',
        'ui.bootstrap',
        'ngDesktopNotification',
        'X5ControleAcesso',
        'angularUtils.directives.dirPagination',
        'app.login',
        'app.layout',
        'app.graphs',
        'app.tables',
        'app.forms',
        'app.ui',
        'app.widgets',
        'app.maps',
        'app.appViews',
        'app.misc',
        'app.smartAdmin',
        'app.painelsupervisor',
        'app.ramais',
        'app.agentes',
        'app.filas',
        'app.cdrfilas',
        'app.cdrfilas_old',
        'app.cdr',
        'app.pausas',
        'app.classificacoes',
        'app.tags',
        'app.classificacoes2',
        'app.agenteeventos',
        'app.agenda',
        'app.usuarios',
        'app.indicadores',
        'app.membros',
        'app.rotas',
        'app.contextos',
        'app.grupos',
        'app.campanhas',
        'app.listas',
        'app.troncos',
        'app.sms',
        'app.filasperformance',
        'app.campanha_importacao',
        'app.agenteperformance',
        'app.campanhaperformance',
        'app.campanhaperformance_old',
        'app.campanhaperformanceagentes',
        'app.audios',
        'app.configuracoes_pesquisa_satisfacao',
        'app.dashboards_pesquisa_satisfacao',
        'app.dashboards_pesquisa_satisfacao_old',
        'app.wizard_mensagens_ura',
        'app.pin',
        'app.luc',
        'app.email',
        'app.layouts',
        'app.tempos',
        'app.ura',
        'app.webchat',
        'app.webchat_old',
        'app.fluxoura',
        'app.abandonosefetivos',
        'app.autocomplete',
        'app.ligacoesura',
        'app.clientes',
        'app.fluxochat',
        'app.atendchat',
        'app.filasperformance_aesc',
        'app.uratexto',
        'app.jbs_discador_relatorios',
        'app.mensagem_classificacoes',
        'app.mensagem_classificacoes_old',
        'app.log',
        'app.online',
        'app.fonteautenticacao',
        'mobx-angularjs'
    ]);

    couchPotato.configureApp(app);

    app.config(function ($provide, $httpProvider, $sceProvider) {
        $sceProvider.enabled(false);

        // Intercept http calls.
        $provide.factory('ErrorHttpInterceptor', function ($q) {
            var errorCounter = 0;
            function notifyError (rejection) {
                $("#x5loading").remove();
                $.bigBox({
                    title: "ERRO " + rejection.status + ' - ' + rejection.statusText,
                    content: rejection.data.msg ? rejection.data.msg : rejection.data.message,
                    color: "#C46A69",
                    icon: "fa fa-warning shake animated",
                    number: ++errorCounter
                });
            }

            return {
                // On request failure
                requestError: function (rejection) {
                    // show notification
                    if (rejection.status == 401) {
                        window.location.hash = "#!login";
                    }
                    notifyError(rejection);

                    // Return the promise rejection.
                    return $q.reject(rejection);
                },

                // On response failure
                responseError: function (rejection) {
                    // show notification
                    if (rejection.status == 401) {
                        window.location.hash = "#!login";
                    }
                    notifyError(rejection);
                    // Return the promise rejection.
                    return $q.reject(rejection);
                }
            };
        });

        // Add the interceptor to the $httpProvider.
        $httpProvider.interceptors.push('ErrorHttpInterceptor');

    });

    app.run(function ($couchPotato, $rootScope, $state, $stateParams, Language, $localStorage, $http, $location, $Store, desktopNotification, $Xcmobx) {
        $rootScope.versao = '3.7.4';
        $rootScope.ano = new Date().getFullYear();

        $rootScope.getWord = function (key) {
            if (angular.isDefined($localStorage.lang) && angular.isDefined($localStorage.lang[key])) {
                return $localStorage.lang[key];
            }
            else {
                return key;
            }
        };

        if ($localStorage.User && $localStorage.User.senha) {
            console.log('------ Mobx -----')
            $Xcmobx.connect({ nome: $localStorage.User.login, senha: decripita($localStorage.User.senha) })
            //if (!$Store.isConnect) {
            //    $Store.connect();
            //}
        }

        function notifica (titulo, texto, icon) {
            try {
                var notif = desktopNotification.show(titulo, {
                    icon: icon,
                    body: texto,
                    autoClose: false,
                    vibrate: true,
                    onClick: function (event) {
                        window.focus();
                        notif.close();
                    }
                });
            } catch (error) {
                console.log(`Erro ao notificar`, error);
            }

        }

        $Store.on('App.QueueCallerAbandon', ev => {
            if ($localStorage.OnlineNotificacoes && $localStorage.OnlineNotificacoes.abandonos) {
                if ($localStorage.User.filas.includes(ev.queue)) {
                    let texto = $rootScope.getWord(`Ligação`) + ' ' + ev.calleridnum + ' ' + $rootScope.getWord('abandonou na fila') + ' ' + ev.queue;
                    console.log(texto);
                    notifica($rootScope.getWord('Xcontact - Ligação abandonada'), texto, 'styles/img/callmis.png');
                }
            }
        });

        $Store.on('App.QueueCallerJoin', ev => {
            if ($localStorage.OnlineNotificacoes && $localStorage.OnlineNotificacoes.aguardando) {
                if ($localStorage.User.filas.includes(ev.queue)) {
                    let texto = $rootScope.getWord(`Ligação`) + ' ' + ev.calleridnum + ' ' + $rootScope.getWord('entrou na fila') + ' ' + ev.queue;
                    console.log(texto);
                    notifica($rootScope.getWord('Xcontact - Nova ligação'), texto, 'styles/img/callin.png');
                }
            }
        });

        $rootScope.$on("$stateChangeStart", function (event, toState, toParams, fromState, fromParams) {
            if ($localStorage.User) {
                $http.defaults.headers.common['Authorization'] = `Bearer ${$localStorage.User.token}`;
            }
        });

        app.lazy = $couchPotato;
        $rootScope.$state = $state;
        $rootScope.$stateParams = $stateParams;
        // editableOptions.theme = 'bs3';

        if ($localStorage.msg) {
            $localStorage.msg = null;
        }

        Language.getLanguages(function (data) {
            if (angular.isDefined($localStorage.currentLanguage)) {
                $rootScope.currentLanguage = $localStorage.currentLanguage;
                for (var i in data) {
                    if ($localStorage.currentLanguage.key === data[i].key) {
                        break;
                    }
                }
            }
            else {
                for (var i in data) {
                    if (options.api.lang === data[i].key) {
                        $rootScope.currentLanguage = data[i];
                        $localStorage.currentLanguage = data[i];
                        break;
                    }
                }
            }

            $rootScope.languages = data;

            Language.getLang(data[i].key, function (data) {
                $localStorage.lang = data;
                $rootScope.lang = data;
            });

        });
    });

    return app;
});
