define(['modules/agenda/module'], function (module) {
    "use strict";

    return module.registerController('GruposCtrl', function ($scope, $http, $stateParams, $rootScope, $state) {
        $scope.row = {};
        $scope.campos_disable = false;
        $scope.order = 'nome';
        $scope.order_sentido = 'ASC';

        if ($rootScope.$state.current.url.indexOf('ver') > 0) {
            $scope.campos_disable = true;
        }

        if ($rootScope.$state.current.url.indexOf('novo') > 0) {
            $http.get(options.api.restv2 + "/contexto?max=-1").
                success(function (data) {
                    $scope.contextos = data.dados;
                });
        }

        $scope.CarregarItem = function (id) {
            if (!id) return;

            $scope.loading = true;
            $http.get(options.api.restv2 + "/agenda/grupo/" + id).
                success(function (data) {
                    $scope.row = data.dados;
                    $scope.loading = false;
                });
        };

        $scope.LoadGrupo = function () {
            if ($stateParams.id) {
                $http.get(options.api.restv2 + "/contexto?max=-1").
                    success(function (data) {
                        $scope.contextos = data.dados;
                        $scope.CarregarItem($stateParams.id);
                    });
            }
        }

        $scope.gotoPage = function (page) {
            let query;
            if ($scope.Pesquisa) {
                query = `/agenda/grupo?max=-1&order=[{"campo":"${$scope.order}","ordem":"${$scope.order_sentido}"}]&nome=${$scope.Pesquisa}`
            } else {
                query = `/agenda/grupo?max=-1&order=[{"campo":"${$scope.order}","ordem":"${$scope.order_sentido}"}]`
            }

            $http.get(options.api.restv3 + query).
                success(function (data) {
                    $scope.table = data;
                    $scope.rows = data.dados;
                });
        };

        // Chamada para primeira pagina
        $scope.load = function () {
            $scope.rows = {};
            $scope.gotoPage(1);
        };

        $scope.Editar = function () {
            $scope.campos_disable = false;
        };

        $scope.Cancelar_editar = function () {
            $scope.CarregarItem($stateParams.id);
            $scope.campos_disable = true;
        };

        $scope.Salvar = function () {
            if ($scope.form.$valid) {
                if ($scope.row.id) {
                    let clId = $scope.row.id
                    delete $scope.row.id
                    $scope.row.id_grupo = $scope.row.grupo
                    delete $scope.row.grupo
                    $http.put(`${options.api.restv2}/agenda/grupo/${clId}`, $scope.row).
                        success(function (data) {
                            $.smallBox({
                                title: "SUCESSO!!",
                                content: "<i class='fa fa-check'></i> <i>Salvo com sucesso!</i>",
                                color: "#739E73",
                                timeout: 6000
                            });
                            $rootScope.$state.transitionTo('app.agenda.grupos');
                        });
                } else {
                    $http.post(options.api.restv2 + "/agendas/grupo", $scope.row).
                        success(function (data) {
                            $.smallBox({
                                title: "SUCESSO!!",
                                content: "<i class='fa fa-check'></i> <i>Salvo com sucesso!</i>",
                                color: "#739E73",
                                timeout: 6000
                            });
                            $rootScope.$state.transitionTo('app.agenda.grupos');
                        });
                }
            }
        };

        $scope.Voltar = function () {
            $rootScope.$state.transitionTo('app.agenda');
        };

        $scope.$watch('Pesquisa', function (t1, t2) {
            // Se os dois valores estirem em branco nao faz nada, isso aconte no load.
            if (!t1 && !t2)
                return false;

            setTimeout(function () {
                if (t1 === $scope.Pesquisa) {
                    var ObPagina;
                    if (t1 === '')
                        ObPagina = { href: options.api.restv2 + "/agenda/grupo" };
                    else
                        ObPagina = { href: options.api.restv2 + "/agenda/grupo/" + t1 };

                    $scope.gotoPage(ObPagina);
                }
            }, 1000);
        });

        $scope.confirma = function (row) {
            $.x5Box({
                title: "Remover <b>" + row.nome + "</b>?",
                content: "Tem certeza que quer remover " + row.nome + "? <p class='text-align-right'><a id='yes' href-void class='btn btn-danger btn-sm btncallback'>Apagar</a> <a id='no' href-void class='btn btn-primary btn-sm btncallback'>Cancelar</a></p>",
                color: "#C46A69",
                //timeout: 8000,
                icon: "fa fa-warning shake animated"
            }, function (ButtonPressed) {
                if (ButtonPressed === "Apagar") {
                    $scope.delete(row.id);
                }
            });
        };

        $scope.delete = function (id) {
            $http.delete(options.api.restv2 + "/agenda/grupo/" + id).
                success(function (s) {
                    $.smallBox({
                        title: "SUCESSO!!",
                        content: "<i class='fa fa-check'></i> <i>Agenda apagada com sucesso!</i>",
                        color: "#739E73",
                        timeout: 6000
                    });

                    $scope.load();
                })
        };

        $scope.getClass = function (coluna) {
            if ($scope.order === coluna) {
                return $scope.order_sentido === 'ASC' ? 'sorting_asc' : 'sorting_desc';
            }
            else {
                return 'sorting';
            }
        };

        $scope.setOrder = function (coluna) {
            if ($scope.order === coluna) {
                $scope.order_sentido = $scope.order_sentido === 'ASC' ? 'DESC' : 'ASC';
            }
            else {
                $scope.order = coluna;
                $scope.order_sentido = 'ASC';
            }
            $scope.gotoPage($scope.links.self);
        };

        $scope.confirma_limpagrupo = function (row) {
            if (!row) {
                $.bigBox({
                    title: "Selecione um grupo!",
                    content: "Você precisa selecionar um grupo para limpar",
                    color: "#C46A69",
                    icon: "fa fa-warning shake animated",
                    timeout: 6000
                });
                return;
            }
            else {
                $.x5Box({
                    title: "LIMPAR grupo <b>" + row.nome + "?</b>",
                    content: "Tem certeza que quer remover todos os números do grupo <b>" + row.nome + "?</b> <p class='text-align-right'><a id='yes' href-void class='btn btn-danger btn-sm btncallback'>Limpar</a> <a id='no' href-void class='btn btn-primary btn-sm btncallback'>Cancelar</a></p>",
                    color: "#C46A69",
                    //timeout: 8000,
                    icon: "fa fa-warning shake animated"
                }, function (ButtonPressed) {
                    if (ButtonPressed === "Limpar") {
                        $scope.limpa_grupo(row.id);
                    }
                });
            }
        };

        $scope.limpa_grupo = function (id) {
            $http.delete(options.api.restv3 + "/agenda/grupo/limpar/" + id).
                success(function (s) {
                    $.smallBox({
                        title: "SUCESSO!!",
                        content: "<i class='fa fa-check'></i> <i>Grupo limpo com sucesso!</i>",
                        color: "#739E73",
                        timeout: 3000
                    });

                    $scope.load();
                })
        };

    });
});