define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource',
    'ngTagsInput',
    'ng-csv',
    'jspdf',
    'autotable',
    'moment',
    'moment-br',
    'moment-timezone',
], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.agenteeventos', [
        'ui.router',
        'ngResource',
        'ngTagsInput',
        'ngCsv'
    ]);


    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.agenteeventos', {
                url: '/agenteeventos',
                data: {
                    title: 'Relatórios de Filas',
                    permissions: {
                        only: ['app.agenteeventos']
                    }
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/agenteeventos/views/lista.html',
                        controller: 'AgenteEventosCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/agenteeventos/controllers/AgenteEventosCtrl',
                                'layout/directives/editPopup',
                                'modules/forms/directives/input/smartSelect2',
                                'modules/forms/directives/input/smartDatepicker',
                                'modules/forms/directives/input/smartTimepicker',
                                'modules/forms/directives/input/smartClockpicker'
                            ])
                        },
                    }
                }
            })
    });

    module.run(function ($couchPotato, Permission, ModuloPermissao, $localStorage, $filter) {
        module.lazy = $couchPotato;
        Permission.defineRole('app.agenteeventos', function () {
            if (!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.agenteeventos", $localStorage.User.modulos)) {
                $localStorage.msg = {
                    tipo: "Erro",
                    txt: "Você não tem acesso ao relatório de eventos dos agentes."
                };
                return false;
            }
            else {
                return true;
            }
        });
    });


    return module;

});