define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource',
    'ngTagsInput',
    'underscore',
    'jspdf',
    'autotable',
    'angularjs-dropdown-multiselect',
    'moment',
    'moment-br',
    'moment-timezone',
    'moment-duration-format',
    'doubleScrollBars'
], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.agenteperformance', [
        'ui.router',
        'ngResource',
        'ngTagsInput',
        'angularjs-dropdown-multiselect',
        'doubleScrollBars'
    ]);


    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.agenteperformance', {
                url: '/agenteperformance',
                data: {
                    title: 'Performance de Agentes',
                    permissions: {
                        only: ['app.agenteperformance']
                    }
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/agenteperformance/views/lista.html',
                        controller: 'AgentePerformanceCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/agenteperformance/controllers/AgentePerformanceCtrl',
                                'modules/ui/directives/smartProgressbar',
                                'modules/forms/directives/input/smartDatepicker',
                                'modules/forms/directives/input/smartTimepicker',
                                'modules/forms/directives/input/smartClockpicker'
                            ])
                        },
                    }
                }
            })
    });

    module.run(function ($couchPotato, Permission, $localStorage, ModuloPermissao) {
        module.lazy = $couchPotato;
        Permission.defineRole('app.agenteperformance', function () {
            if (!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.agenteperformance", $localStorage.User.modulos)) {
                $localStorage.msg = {
                    tipo: "Erro",
                    txt: "Você não tem acesso ao relatório de agentes."
                };
                return false;
            }
            else {
                return true;
            }
        });
    });


    return module;

});