define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource',
    'summernote',
    'summernote-pt-BR',
    'angular-summernote'
], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.agentes', [
        'ui.router',
        'ngResource',
        'summernote'
    ]);


    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.agentes', {
                url: '/agentes',
                data: {
                    title: 'Agentes',
                    permissions: {
                        only: ['app.agentes']
                    }
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/agentes/views/lista.html',
                        controller: 'AgentesCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/agentes/controllers/AgentesCtrl'
                            ])
                        },
                    }
                }
            })

            .state('app.agentes.editar', {
                url: '/editar/:id',
                data: {
                    title: 'Agentes',
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/agentes/views/form.html',
                        controller: 'AgentesCtrl',
                        parent: 'app.agentes',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/agentes/controllers/AgentesCtrl'
                            ])
                        }
                    }
                }
            })

            .state('app.agentes.novo', {
                url: '/novo',
                data: {
                    title: 'Novo Agente',
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/agentes/views/form.html',
                        controller: 'AgentesCtrl',
                        parent: 'app.agentes',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/agentes/controllers/AgentesCtrl'
                            ])
                        }
                    }
                }
            })

            .state('app.agentes.ver', {
                url: '/ver/:id',
                data: {
                    title: 'Agente',
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/agentes/views/form.html',
                        controller: 'AgentesCtrl',
                        parent: 'app.agentes',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/agentes/controllers/AgentesCtrl'
                            ])
                        }
                    }
                }
            })
    });

    module.run(function ($couchPotato, Permission, ModuloPermissao, $localStorage, $filter) {
        module.lazy = $couchPotato;
        Permission.defineRole('app.agentes', function () {
            if (!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.agentes", $localStorage.User.modulos)) {
                $localStorage.msg = {
                    tipo: "Erro",
                    txt: "Você não tem acesso ao módulo de Agentes."
                };
                return false;
            } else {
                return true;
            }
        });
    });

    return module;

});