define(['modules/audios/module'], function (module) {
    "use strict";

    return module.registerController('DiretoriosCtrl', function ($scope, Upload, $localStorage, $http, $rootScope) {
        $scope.row = {};
        $scope.filtro = {};
        $scope.sorts = [
            { id: 'alpha', nome: $scope.getWord('Alfabética') },
            { id: 'random', nome: $scope.getWord('Aleatória') },
        ];


        $scope.getLinkGravacao = function (l1) {
            if (l1) {
                let user = encodeURI($localStorage.User.token);
                let arquivo = encodeURI(l1);
                return `${options.api.restv4}/audios?access_token=${user}&caminho=${arquivo}`;
            }
        };

        $scope.getNome = function (l1) {
            if (l1) {
                return l1.substr(0, l1.lastIndexOf("."));
            }
        };

        $scope.getFileName = function (l1) {
            if (l1) {
                return l1.substr(l1.lastIndexOf("/") + 1);
            }
        };

        $scope.NovoDiretorio = function (row) {
            $scope.showAudioPopup = true;
            $scope.dir = {};
            $scope.dir.sort = 'random';
        };


        $scope.gotoPage = function (page) {
            $scope.filtro.page = { valor: page };
            $scope.load();
        };

        // Chamada para primeira pagina
        $scope.load = function () {
            $scope.carregando = true;
            var par = [];
            if ($scope.filtro) {
                angular.forEach($scope.filtro, function (v, k) {
                    if (v) par.push(k + "=" + v.valor);
                });
            }
            var pars = "";
            if (par.length > 0) {
                pars = "&" + par.join("&");
                console.log(pars);
            }
            $http.get(options.api.restv2 + "/audios?max=15" + pars).
                success(function (data) {
                    $scope.table = data;
                    $scope.carregando = false;
                });
        };

        $scope.Save = function (f1) {
            if (f1.$valid) {
                console.log($scope.dir);
                $http.post(options.api.restv2 + "/audio/diretorio", $scope.dir).
                    success(function (data) {
                        $.smallBox({
                            title: "SUCESSO!!",
                            content: "<i class='fa fa-check'></i> <i>Salvo com sucesso!</i>",
                            color: "#739E73",
                            timeout: 2000
                        });
                        $scope.load();
                        $scope.showAudioPopup = false;
                    })
            }
        };

        $scope.Voltar = function () {
            $rootScope.$state.transitionTo('app.audio');
        };

        $scope.$watch('Pesquisa', function (t1, t2) {
            // Se os dois valores estirem em branco nao faz nada, isso aconte no load.
            if (!t1 && !t2)
                return false;

            setTimeout(function () {
                if (t1 === $scope.Pesquisa) {
                    if (t1 !== '') {
                        $scope.filtro.nome = { valor: t1 };
                    }
                    else {
                        $scope.filtro.nome = undefined;
                    }

                    $scope.load();
                }
            }, 1000);
        });

        $scope.confirma = function (row) {
            $.x5Box({
                title: "Remover diretório <b>" + row.name + "</b>?",
                content: "Tem certeza que quer remover esse diretório? <p class='text-align-right'><a id='yes' href-void class='btn btn-danger btn-sm btncallback'>Apagar</a> <a id='no' href-void class='btn btn-primary btn-sm btncallback'>Cancelar</a></p>",
                color: "#C46A69",
                //timeout: 8000,
                icon: "fa fa-warning shake animated"
            }, function (ButtonPressed) {
                if (ButtonPressed === "Apagar") {
                    $scope.delete(row.directory);
                }
            });
        };

        $scope.delete = function (id) {
            $http.delete(options.api.restv2 + "/audio/diretorio?dir_name=" + id).
                success(function (s) {
                    $.smallBox({
                        title: "SUCESSO!!",
                        content: "<i class='fa fa-check'></i> <i>Diretório apagado com sucesso!</i>",
                        color: "#739E73",
                        timeout: 2000
                    });
                    $scope.load();
                })
        };

        $scope.confirma_audio = function (row) {
            $.x5Box({
                title: "Remover arquivo <b>" + $scope.getFileName(row) + "</b>?",
                content: "Tem certeza que quer remover esse arquivo? <p class='text-align-right'><a id='yes' href-void class='btn btn-danger btn-sm btncallback'>Apagar</a> <a id='no' href-void class='btn btn-primary btn-sm btncallback'>Cancelar</a></p>",
                color: "#C46A69",
                //timeout: 8000,
                icon: "fa fa-warning shake animated"
            }, function (ButtonPressed) {
                if (ButtonPressed === "Apagar") {
                    $scope.delete_audio(row);
                }
            });
        };

        $scope.delete_audio = function (id) {
            $http.delete(options.api.restv2 + "/audio?file_name=" + encodeURI(id)).
                success(function (s) {
                    $.smallBox({
                        title: "SUCESSO!!",
                        content: "<i class='fa fa-check'></i> <i>Arquivo apagado com sucesso!</i>",
                        color: "#739E73",
                        timeout: 2000
                    });
                    $scope.load();
                })
        };

        $scope.getClass = function (coluna) {
            if ($scope.order === coluna) {
                return $scope.order_sentido === 'ASC' ? 'sorting_asc' : 'sorting_desc';
            }
            else {
                return 'sorting';
            }
        };

        $scope.setOrder = function (coluna) {
            if ($scope.order === coluna) {
                $scope.order_sentido = $scope.order_sentido === 'ASC' ? 'DESC' : 'ASC';
            }
            else {
                $scope.order = coluna;
                $scope.order_sentido = 'ASC';
            }
            $scope.gotoPage($scope.links.self);
        };

        $scope.uploadFiles = function (files, id) {
            $scope.files = files;
            $scope.carregando_arquivos = true;
            var i = 0;
            angular.forEach($scope.files, function (file) {
                if (file && !file.$error) {
                    file.upload = Upload.upload({
                        url: options.api.restv2 + "/audio/upload/" + id,
                        file: file
                    });

                    file.upload.then(function (resp) {
                        i++;
                        if (i === $scope.files.length) {
                            $.smallBox({
                                title: "SUCESSO!!",
                                content: "<i class='fa fa-check'></i> <i> Arquivos enviado com sucesso!</i>",
                                color: "#739E73",
                                timeout: 2000
                            });
                            $scope.carregando_arquivos = false;
                            $scope.load();
                        }

                    }, function (resp) {
                        i++;
                        console.log('Error status: ' + resp.status);
                        $scope.carregando_arquivos = false;
                    }, function (evt) {
                        file.progress = parseInt(100.0 * evt.loaded / evt.total);
                        //console.log(file);
                        //console.log('progress: ' + progressPercentage + '% ');
                    });
                }
            });
        };

    });
});
