define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource',        
    'ngTagsInput',
    'underscore',
    'jspdf',
    'autotable',
    'moment',
    'moment-br',
    'moment-timezone',
], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.campanhaperformance', [
        'ui.router',
        'ngResource',        
        'ngTagsInput',
        'angularjs-dropdown-multiselect'
    ]);

    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.campanhaperformance', {
                url: '/campanha_performance',                
                data: {
                    title: 'Performance da campanha',
                    permissions: {
                        only: ['app.campanhaperformance']
                    }
                },                
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/campanha_performance/views/lista.html',
                        controller: 'CampanhaPerformanceCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([                                
                                'modules/campanha_performance/controllers/CampanhaPerformanceCtrl',
                                'modules/ui/directives/smartProgressbar',
                                'modules/forms/directives/input/smartDatepicker',
                                'modules/forms/directives/input/smartTimepicker',
                                'modules/forms/directives/input/smartClockpicker'
                            ])
                        },                        
                    }
                }
            })
    });

    module.run(function ($couchPotato,Permission,$localStorage,ModuloPermissao) {
        module.lazy = $couchPotato;        
        Permission.defineRole('app.campanhaperformance', function () {
            if(!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.campanhaperformance", $localStorage.User.modulos)){
               $localStorage.msg = {
                   tipo: "Erro",
                   txt: "Você não tem acesso ao relatório de campanhas."
               };               
               return false;
            }            
            else {                
                return true;         
            }
        });
    });


    return module;

});