define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource',
    'ngTagsInput',
    'underscore',
    'jspdf',
    'autotable',
    'moment',
    'moment-br',
    'moment-timezone',
], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.campanhaperformance_old', [
        'ui.router',
        'ngResource',
        'ngTagsInput',
        'angularjs-dropdown-multiselect'
    ]);

    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.campanhaperformance_old', {
                url: '/campanha_performance_old',
                data: {
                    title: 'Performance da campanha (OLD)',
                    permissions: {
                        only: ['app.campanhaperformance_old']
                    }
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/campanha_performance_old/views/lista.html',
                        controller: 'CampanhaPerformanceOldCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/campanha_performance_old/controllers/CampanhaPerformanceOldCtrl',
                                'modules/ui/directives/smartProgressbar',
                                'modules/forms/directives/input/smartDatepicker',
                                'modules/forms/directives/input/smartTimepicker',
                                'modules/forms/directives/input/smartClockpicker'
                            ])
                        },
                    }
                }
            })
    });

    module.run(function ($couchPotato, Permission, $localStorage, ModuloPermissao) {
        module.lazy = $couchPotato;
        Permission.defineRole('app.campanhaperformance_old', function () {
            if (!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.campanhaperformance_old", $localStorage.User.modulos)) {
                $localStorage.msg = {
                    tipo: "Erro",
                    txt: "Você não tem acesso ao relatório de campanhas (OLD)."
                };
                return false;
            }
            else {
                return true;
            }
        });
    });


    return module;

});