define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource',
    'ng-csv',
    'ngTagsInput',
    'jspdf',
    'autotable'
], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.cdr', [
        'ui.router',
        'ngResource',
        'ngCsv',
        'ngTagsInput'
    ]);


    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.cdr', {
                url: '/cdr',                
                data: {
                    title: 'Relatórios de Ligações',
                    permissions: {
                        only: ['app.cdr']
                    }
                },                
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/cdr/views/lista.html',
                        controller: 'CdrCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/cdr/controllers/CdrCtrl',
                                'modules/forms/directives/input/smartSelect2',
                                'modules/forms/directives/input/smartDatepicker',
                                'modules/forms/directives/input/smartTimepicker',
                                'modules/forms/directives/input/smartClockpicker'
                            ])
                        },                        
                    }
                }
            })
    });

    module.run(function ($couchPotato,Permission,$localStorage,ModuloPermissao) {
        module.lazy = $couchPotato;        
        Permission.defineRole('app.cdr', function () {
            if(!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.cdr",$localStorage.User.modulos)){
               $localStorage.msg = {
                   tipo: "Erro",
                   txt: "Você não tem acesso ao relatório de ligações."
               };               
               return false;
            }            
            else {                
                return true;         
            }
        });
    });

    return module;

});