define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource',
    'ng-csv',
    'jspdf',
    'underscore',
    'ngTagsInput',
    'autotable'
], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.cdrfilas_old', [
        'ui.router',
        'ngResource',
        'ngCsv',
        'ngTagsInput'
    ]);


    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.cdrfilas_old', {
                url: '/cdrfilas_old',
                data: {
                    title: 'Relatórios de Filas',
                    permissions: {
                        only: ['app.cdrfilas_old']
                    }
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/cdrfilas_old/views/lista.html',
                        controller: 'CdrFilasOldCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/cdrfilas_old/controllers/CdrFilasOldCtrl',
                                'modules/forms/directives/input/smartSelect2',
                                'modules/forms/directives/input/smartDatepicker',
                                'modules/forms/directives/input/smartTimepicker',
                                'modules/forms/directives/input/smartClockpicker'
                            ])
                        },
                    }
                }
            })
    });

    module.run(function ($couchPotato, Permission, $localStorage, ModuloPermissao) {
        module.lazy = $couchPotato;
        Permission.defineRole('app.cdrfilas_old', function () {
            if (!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.cdrfilas_old", $localStorage.User.modulos)) {
                $localStorage.msg = {
                    tipo: "Erro",
                    txt: "Você não tem acesso ao relatório de filas."
                };
                return false;
            }
            else {
                return true;
            }
        });
    });


    return module;

});