define(['modules/classificacoes/module', 'jquery-maskedinput', 'jquery-validation'], function (module) {

    'use strict';

    return module.registerDirective('showPopupsub', function () {
        return {
            restrict: 'E',
            replace: true,
            transclude: true,
            templateUrl: 'app/modules/classificacoes/views/sub.popup.html',
            scope: true,
            link: function postLink(scope, element, attrs) {
                scope.title = attrs.title;
                scope.$watch(attrs.visible, function(value){
                  if(value === true)
                    $(element).modal('show');
                  else
                    $(element).modal('hide');
                });

                var modalUniqueClass = ".modal";
                $('.modal').on('show.bs.modal', function(e) {
                    var $element = $(this);
                    var $uniques = $(modalUniqueClass + ':visible').not($(this));
                    if ($uniques.length) {
                      $uniques.modal('hide');
                      $uniques.one('hidden.bs.modal', function(e) {
                        $element.modal('show');
                      });
                      return false;
                    }
                });

                $(element).on('hidden.bs.modal', function(){
                  scope.$apply(function(){
                    scope.$parent[attrs.visible] = false;
                  });
                });
            }
        };
    });
});
