const { findIndex } = require("lodash");

define(['modules/filas/module'], function (module) {
    "use strict";

    return module.registerController('FilasCtrl', function ($scope, $http, WhatsApiService, $stateParams, $rootScope) {
        //console.log(WhatsApiService);
        WhatsApiService.connect();
        WhatsApiService.on('connect', function () {
            console.log('Conexão com websocket aberta com o WhatApi no Xcontact server.');
            //var token = {token: "1e5a475b7421c20cf0edb60543b20d406a2e55fd2619f5f04ee10dbdc41a007b"};
            //SocketService.emit('authentication',JSON.stringify(token));
        });

        WhatsApiService.on('newQrCode', (data) => {
            //console.log('Recebendo novo qrcode...');
            if ($scope.pop && $scope.pop.name == data.instanceID) {
                //console.log('Temos pop');
                $scope.WhatsApi.qrCode = data.qrCode;
                $scope.WhatsApi.Msg = undefined;
            }
        });

        WhatsApiService.on('WhatsStatus', (data) => {
            console.log('Recebendo novo WhatsStatus...', data);
            if ($scope.pop && $scope.pop.name == data.instanceID) {
                console.log('Temos pop');
                $scope.WhatsApi.qrCode = data.qrCode;
                $scope.WhatsApi.qrCodeNeedRefresh = data.qrCodeNeedRefresh;

                $scope.WhatsApi.Fone = {
                    conn: data.FoneCon,
                    bat: data.FoneBateria,
                    plug: data.FonePlug,
                    Me: data.Me
                };
                if (data.FoneBateria) {
                    if (data.FoneBateria <= 15) $scope.WhatsApi.Fone.batA = true;
                    else if (data.FoneBateria > 15 && data.FoneBateria < 30) $scope.WhatsApi.Fone.batB = true;
                    else if (data.FoneBateria > 30 && data.FoneBateria < 45) $scope.WhatsApi.Fone.batC = true;
                    else $scope.WhatsApi.Fone.batD = true;
                }
            }
        });

        $scope.filtro = {};
        $scope.order = [{ "campo": "name", "ordem": "ASC" }];


        var tipos = [
            { 'id': 1, 'nome': 'Voz', 'icon': 'fa fa-phone' },
            { 'id': 2, 'nome': 'Webchat', 'icon': 'fa fa-comments' },
            { 'id': 3, 'nome': 'WhatsApp', 'icon': 'fa fa-whatsapp' },
            { 'id': 4, 'nome': 'Email', 'icon': 'fa fa-envelope-o' },
            { 'id': 5, 'nome': 'WhatsApp(Zenvia)', 'icon': 'fa fa-whatsapp' },
            { 'id': 6, 'nome': 'WhatsApp(Infobip)', 'icon': 'fa fa-whatsapp' },
            { 'id': 7, 'nome': 'WhatsApp(Gupshup)', 'icon': 'fa fa-whatsapp' },
            { 'id': 8, 'nome': 'Facebook', 'icon': 'fa fa-facebook-square' },
            { 'id': 9, 'nome': 'Vídeo', 'icon': 'fa fa-video-camera' },
        ];

        $scope.options = {
            height: 200,
            focus: false,
            airMode: false,
            toolbar: [
                ['headline', ['style']],
                ['style', ['bold', 'italic', 'underline']],
                ['textsize', ['fontsize']],
                ['fontclr', ['color']],
                ['alignment', ['ul', 'ol', 'paragraph', 'lineheight']]
            ]
        };

        $scope.row = {};
        $scope.row.nivel_tempo = 20;
        $scope.row.nivel_abandono_tempo = 40;

        $scope.calculo = {};
        $scope.campos_disable = false;
        $scope.campos_nao_editavel = false;
        $scope.musicas = [];

        $scope.AcoesPreAtendimento = [
            { 'cmd': 'Fila', 'nome': $scope.getWord('Fila') },
            { 'cmd': 'TextoFinal', 'nome': $scope.getWord('Mensagem') }
        ];

        $scope.autopausas = [
            { 'id': 'no', 'nome': $scope.getWord('Não') },
            { 'id': 'yes', 'nome': $scope.getWord('Sim - Apenas na fila que não atendeu') },
            { 'id': 'all', 'nome': $scope.getWord('Sim - Todas as filas') }
        ];

        $scope.email_flags = [
            { value: 'ALL', 'nome': $scope.getWord('Todos os emails') },
            { value: 'UNSEEN', 'nome': $scope.getWord('Emails não visualizados') },
            { value: 'UNANSWERED', 'nome': $scope.getWord('Emails não respondidos') },
            { value: 'ANSWERED', 'nome': $scope.getWord('Emails respondidos') },
            { value: 'DELETED', 'nome': $scope.getWord('Emails apagados') },
            { value: 'DRAFT', 'nome': $scope.getWord('Emails em rascunho') },
            { value: 'FLAGGED', 'nome': $scope.getWord('Emails marcados') },
            { value: 'NEW', 'nome': $scope.getWord('Emails novos') },
            { value: 'SEEN', 'nome': $scope.getWord('Emails visualizados') },
            { value: 'RECENT', 'nome': $scope.getWord('Emails recentes') },
            { value: 'OLD', 'nome': $scope.getWord('Emails antigos') },
            { value: 'UNDELETED', 'nome': $scope.getWord('Emails não apagados') },
            { value: 'UNDRAFT', 'nome': $scope.getWord('Emails sem rascunhos') },
            { value: 'UNFLAGGED', 'nome': $scope.getWord('Emails não marcados') },
        ];

        $scope.estrategias = [
            { 'nome': $scope.getWord('Tocar em todos'), 'cmd': 'ringall' },
            { 'nome': $scope.getWord('Cíclico'), 'cmd': 'rrmemory' },
            { 'nome': $scope.getWord('No que está há mais tempo sem atender'), 'cmd': 'leastrecent' },
            { 'nome': $scope.getWord('No que menos atende'), 'cmd': 'fewestcalls' },
            { 'nome': $scope.getWord('Sorteio'), 'cmd': 'random' },
            { 'nome': $scope.getWord('Linear'), 'cmd': 'linear' }
        ];

        $scope.joinempty_opcoes = [
            { 'cmd': 'paused', 'nome': $scope.getWord('Todos em Pausas') },
            { 'cmd': 'penalty', 'nome': $scope.getWord('Todos Penalizados') },
            { 'cmd': 'inuse', 'nome': $scope.getWord('Todos Ocupados') },
            { 'cmd': 'ringing', 'nome': $scope.getWord('Todos tocando') },
            { 'cmd': 'unavailable', 'nome': $scope.getWord('Todos indisponíveis') },
            { 'cmd': 'invalid', 'nome': $scope.getWord('Todos inválidos') },
            { 'cmd': 'unknown', 'nome': $scope.getWord('Todos desconhecidos') },
            { 'cmd': 'wrapup', 'nome': $scope.getWord('Todos em pausa produtiva') }
        ];

        $scope.getTurnos = function () {
            $http.get(options.api.restv2 + "/horarios?max=-1&tipo=T").
                success(function (data) {
                    $scope.turnos = data.dados;
                });
        };

        $scope.getPesquisas = function () {
            $http.get(options.api.restv2 + "/pesquisas?max=-1").
                success(function (data) {
                    $scope.pesquisas = data;
                });
        };

        $scope.filterTurnos = function (query) {
            return $scope.turnos.filter(function (t) {
                return t.nome.toLowerCase().indexOf(query.toLowerCase()) !== -1;
            });
        };

        $scope.filterEmailFlags = function (query) {
            return $scope.email_flags.filter(function (t) {
                return t.nome.toLowerCase().indexOf(query.toLowerCase()) !== -1;
            });
        };

        $scope.getMusicas = function () {
            $http.get(options.api.restv2 + "/audios/diretorios?max=-1").
                success(function (data) {
                    $scope.musicas = data.dados;
                });
        };

        $scope.getJoinEmptyOpcao = function (query) {
            var opcoes = $scope.joinempty_opcoes;
            return opcoes.filter(function (op) {
                return op.nome.toLowerCase().indexOf(query.toLowerCase()) !== -1;
            });
        };

        $scope.getEstrategiaNome = function (cmd) {
            for (var i = 0; i < $scope.estrategias.length; i++) {
                if (cmd == $scope.estrategias[i].cmd) {
                    return $scope.estrategias[i].nome;
                }
            }
        };

        $scope.getYesOrNo = function (t) {
            var a = [];
            a["no"] = "não";
            a["yes"] = "sim";
            return a[t];
        };

        if ($rootScope.$state.current.url.indexOf('ver') > 0) {
            $scope.campos_disable = true;
            $scope.campos_nao_editavel = true;
        }

        $scope.CarregarItem = function (name) {
            $http.get(options.api.restv2 + "/fila/" + name).
                success(function (data) {
                    $scope.row = data;
                    if ($scope.row.strategy) {
                        angular.forEach($scope.estrategias, function (e) {
                            if (e.cmd == $scope.row.strategy) {
                                $scope.row.strategy = e;
                                return;
                            }
                        });
                    }
                    if (data.joinempty) {
                        var selecionadas = data.joinempty.match(/("[^"]*")|[^,]+/g);
                        $scope.row.joinempty = [];
                        angular.forEach(selecionadas, function (sel) {
                            angular.forEach($scope.joinempty_opcoes, function (op) {
                                if (op.cmd === sel) {
                                    $scope.row.joinempty.push(op);
                                }
                            });
                        });
                    }
                    if (data.leavewhenempty) {
                        var selecionadas2 = data.leavewhenempty.match(/("[^"]*")|[^,]+/g);
                        $scope.row.leavewhenempty = [];
                        angular.forEach(selecionadas2, function (sel) {
                            angular.forEach($scope.joinempty_opcoes, function (op) {
                                if (op.cmd === sel) {
                                    $scope.row.leavewhenempty.push(op);
                                }
                            });
                        });
                    }

                    if (data.id_calculo_nivel) {
                        data.calculo = $scope.calculos_nivel.find(x => x.id === data.id_calculo_nivel);
                    }
                });
        };

        $scope.getCalculos = function () {
            $scope.loading = true;
            $http.get(options.api.rest + "/calculos_nivelservico").
                success(function (data) {
                    $scope.calculos_nivel = data.itens;
                    $scope.loading = false;
                    if ($rootScope.$state.current.name === 'app.filas.editar') {
                        $scope.CarregarItem($stateParams.id);
                    }
                });
        };

        $scope.getCalculosPerformance = function () {
            $http.get(options.api.rest + "/calculos_performance?max=0").
                success(function (data) {
                    $scope.calculos_performance = data.itens;
                });
        };

        $scope.getCalculo = function (id) {
            $http.get(options.api.rest + "/calculo_nivelservico/" + id).
                success(function (data) {
                    $scope.calculo = data;
                });
        };

        $scope.getCamposCalculo = function () {
            $http.get(options.api.rest + "/calculos_nivelservico_variaveis").
                success(function (data) {
                    $scope.campos = data.itens;
                });
        };

        $scope.setDescricaoNivel = function (d) {
            //console.log(d);
            $scope.descricao_nivel = d;
        };

        if ($rootScope.$state.current.name === 'app.filas.editar') {
            $scope.getCalculos();
            $scope.getCalculosPerformance();
            $scope.getMusicas();
            $scope.campos_nao_editavel = true;
        }

        if ($rootScope.$state.current.url.indexOf('novo') > 0) {
            $scope.getCalculos();
            $scope.getCalculosPerformance();
            $scope.getMusicas();
            $scope.campos_nao_editavel = false;
            $scope.campos_disable = false;
            $scope.row.timeout = 30;
            $scope.row.maxlen = 0;
            $scope.row.retry = 0;
            $scope.row.autopause = 'all';
            $scope.row.autofill = 'yes';
            $scope.row.announce_holdtime = 'yes';
            $scope.row.announce_frequency = 60;
        }

        $scope.init = function () {
            $scope.filtro.page = { valor: 1 };
            $scope.load();
        };

        $scope.gotoPage = function (page) {
            $scope.filtro.page = { valor: page };
            $scope.load();
        };

        // Chamada para primeira pagina
        $scope.load = function () {
            $scope.carregando = true;
            var par = [];
            if ($scope.filtro) {
                angular.forEach($scope.filtro, function (v, k) {
                    if (v) par.push(k + "=" + v.valor);
                });
            }
            var pars = "";
            if (par.length > 0) {
                pars = "&" + par.join("&");
            }
            $http.get(options.api.restv2 + "/filas?max=15&order=" + encodeURI(JSON.stringify($scope.order)) + pars).
                success(function (data) {
                    $scope.table = data;
                    $scope.carregando = false;
                });
        };

        $scope.filterFila = function (param) {
            return function (item) {
                if (item.name != param) {
                    return true;
                }
                return false;
            };
        };

        $scope.getFilas = () => {
            $http.get(options.api.restv2 + "/filas?max=-1&order=" + encodeURI(JSON.stringify($scope.order))).
                success(function (data) {
                    //console.log(data);
                    $scope.FilasOmmi = data.dados.filter((fila) => {
                        return fila.queue_type != '1';
                    })
                    $scope.FilasFoz = data.dados.filter((fila) => {
                        return fila.queue_type == '1';
                    })
                    $scope.FilasWebchat = data.dados.filter((fila) => {
                        return fila.queue_type == '2';
                    })
                    $scope.FilasWhats = data.dados.filter((fila) => {
                        return fila.queue_type == '3';
                    })
                    $scope.FilasEmail = data.dados.filter((fila) => {
                        return fila.queue_type == '4';
                    })
                    $scope.FilasZenvia = data.dados.filter((fila) => {
                        return fila.queue_type == '5';
                    })
                    $scope.FilasInfobip = data.dados.filter((fila) => {
                        return fila.queue_type == '6';
                    })
                    // Gupshup
                    $scope.FilasGupshup = data.dados.filter((fila) => {
                        return fila.queue_type == '7';
                    })
                    $scope.FilasFace = data.dados.filter((fila) => {
                        return fila.queue_type == '8';
                    })
                });
        };

        $scope.LoadCalculos = function () {
            $scope.getCalculos();
        };

        $scope.LoadCalculo = function () {
            $scope.getCamposCalculo();

            if ($rootScope.$state.current.name === 'app.filas.calculos_editar') {
                $scope.getCalculo($stateParams.id);
            }
            //console.log();
        };

        $scope.Cancelar_editar = function () {
            $scope.CarregarItem($stateParams.id);

            if ($scope.row.strategy) {
                angular.forEach($scope.estrategias, function (e) {
                    if (e.cmd == $scope.row.strategy) {
                        $scope.row.strategy = e;
                        return;
                    }
                });
            }

            $scope.campos_disable = true;
            $scope.campos_nao_editavel = true;
        };

        $scope.SalvarCalculo = function () {
            if ($scope.formcalculo.$valid) {
                $http.post(options.api.rest + "/calculo_nivelservico", $scope.calculo).
                    success(function (data) {
                        $.smallBox({
                            title: "SUCESSO!!",
                            content: "<i class='fa fa-check'></i> <i>Salvo com sucesso!</i>",
                            color: "#739E73",
                            timeout: 2000
                        });
                        $rootScope.$state.transitionTo('app.filas.calculos');
                    })
            }
        };

        $scope.confirmaCalculo = function (row) {
            $.x5Box({
                title: "Remover <b>" + row.nome + "</b>?",
                content: "Tem certeza que quer remover " + row.nome + "? <p class='text-align-right'><a id='yes' href-void class='btn btn-danger btn-sm btncallback'>Apagar</a> <a id='no' href-void class='btn btn-primary btn-sm btncallback'>Cancelar</a></p>",
                color: "#C46A69",
                //timeout: 8000,
                icon: "fa fa-warning shake animated"
            }, function (ButtonPressed) {
                if (ButtonPressed === "Apagar") {
                    $scope.ApagaCalculo(row.id);
                }
            });
        };

        $scope.ApagaCalculo = function (id) {
            $http.delete(options.api.rest + "/calculo_nivelservico/" + id).
                success(function (data) {
                    $.smallBox({
                        title: "SUCESSO!!",
                        content: "<i class='fa fa-check'></i> <i>Apagado com sucesso!</i>",
                        color: "#739E73",
                        timeout: 2000
                    });
                    $scope.LoadCalculos();
                })
        };

        $scope.Salvar = function (f1) {
            if (f1.$valid) {
                var fila = angular.copy($scope.row);
                fila.strategy = fila.strategy.cmd;
                if (fila.calculo) {
                    fila.id_calculo_nivel = fila.calculo.id;
                    delete fila.calculo;
                }
                if (fila.performance_agentes) {
                    fila.id_calculo_performance = fila.performance_agentes.id;
                    delete fila.performance_agentes;
                }

                if (fila.joinempty && fila.joinempty.length > 0) {
                    fila.joinempty = [];
                    angular.forEach($scope.row.joinempty, function (f) {
                        fila.joinempty.push(f.cmd);
                    });
                    fila.joinempty = fila.joinempty.join(',');
                } else {
                    fila.joinempty = null;
                }

                if (fila.leavewhenempty && fila.leavewhenempty.length > 0) {
                    fila.leavewhenempty = [];
                    angular.forEach($scope.row.leavewhenempty, function (f) {
                        fila.leavewhenempty.push(f.cmd);
                    });
                    fila.leavewhenempty = fila.leavewhenempty.join(',');
                } else {
                    fila.leavewhenempty = null;
                }

                if (fila.id) {
                    delete fila.id;
                    $http.put(options.api.restv2 + "/fila/" + $scope.row.name, fila).
                        success(function (data) {
                            $scope.showFilaPopup = false;
                            $.smallBox({
                                title: "SUCESSO!!",
                                content: "<i class='fa fa-check'></i> <i>Fila criada com sucesso!</i>",
                                color: "#739E73",
                                timeout: 2000
                            });
                            $scope.load();
                        });
                }
                else {
                    $http.post(options.api.restv2 + "/fila", fila).
                        success(function (data) {
                            $scope.showFilaPopup = false;
                            $.smallBox({
                                title: "SUCESSO!!",
                                content: "<i class='fa fa-check'></i> <i>Fila " + fila.name + " criada!</i>",
                                color: "#739E73",
                                timeout: 2000
                            });
                            $scope.load();
                        });
                }
            }
        };

        $scope.Voltar = function () {
            $rootScope.$state.transitionTo('app.filas');
        };

        $scope.$watch('Pesquisa', function (t1, t2) {
            // Se os dois valores estirem em branco nao faz nada, isso aconte no load.
            if (!t1 && !t2)
                return false;

            setTimeout(function () {
                if (t1 === $scope.Pesquisa) {
                    var ObPagina;
                    if (t1 === '') {
                        delete $scope.filtro.nome;
                    }
                    else {
                        $scope.filtro.page = { valor: 1 };
                        $scope.filtro.nome = { valor: t1 };
                    }

                    $scope.load();
                }
            }, 1000);
        });

        $scope.confirma = function (row) {
            $.x5Box({
                title: "Remover fila <b>" + row.name + "</b>?",
                content: "Tem certeza que quer remover a fila " + row.name + "?<br><br><small>Todas as campanhas associadas a esta fila deixarão de ser apresentadas.<br>Se possuir campanhas atreladas nesta fila, é altamente indicado que as migre para outra fila antes de excluir esta.</small><p class='text-align-right'><a id='yes' href-void class='btn btn-danger btn-sm btncallback'>Apagar</a> <a id='no' href-void class='btn btn-primary btn-sm btncallback'>Cancelar</a></p>",
                color: "#C46A69",
                //timeout: 8000,
                icon: "fa fa-warning shake animated"
            }, function (ButtonPressed) {
                if (ButtonPressed === "Apagar") {
                    $scope.delete(row.name);
                }
            });
        };

        $scope.delete = function (id) {
            $http.delete(options.api.restv2 + "/fila/" + id).
                success(function (s) {
                    $.smallBox({
                        title: "SUCESSO!!",
                        content: "<i class='fa fa-check'></i> <i>Fila apagada com sucesso!</i>",
                        color: "#739E73",
                        timeout: 2000
                    });

                    $scope.load();
                })
        };

        $scope.getClass = function (coluna) {
            if ($scope.order[0].campo === coluna) {
                return $scope.order[0].ordem === 'ASC' ? 'sorting_asc' : 'sorting_desc';
            }
            else {
                return 'sorting';
            }
        };

        $scope.setOrder = function (coluna) {
            if ($scope.order[0].campo === coluna) {
                $scope.order[0].ordem = $scope.order[0].ordem === 'ASC' ? 'DESC' : 'ASC';
            }
            else {
                $scope.order = [{ "campo": coluna, "ordem": "ASC" }];
            }
            $scope.load();
        };

        $scope.showpopupcalculo = function () {
            $scope.showModalCalculo = true;
        };

        $scope.showTypePopup = function () {
            $scope.showTypesPopup = true;
        };

        $scope.GotoVoz = function () {
            $scope.row = {};
            $scope.getCalculos();
            $scope.getCalculosPerformance();
            $scope.getMusicas();
            $scope.campos_nao_editavel = false;
            $scope.campos_disable = false;
            $scope.row.timeout = 30;
            $scope.row.maxlen = 0;
            $scope.row.retry = 0;
            $scope.row.autopause = 'all';
            $scope.row.autofill = 'yes';
            $scope.row.announce_holdtime = 'yes';
            $scope.row.announce_frequency = 60;

            $scope.showTypesPopup = false;
            $scope.showFilaPopup = true;
            //$rootScope.$state.transitionTo('app.filas.novo');
        };

        $scope.getFilas()
        $scope.filasTransbordo = []

        $scope.Editar = function ($r) {
            //console.log($r);            
            switch ($r.queue_type) {
                case 1:
                    $scope.getCalculos();
                    $scope.getCalculosPerformance();
                    $scope.getMusicas();
                    $scope.CarregarItem($r.name);
                    $scope.campos_nao_editavel = true;
                    $scope.showFilaPopup = true;
                    break;
                case 2:
                    $r.load = true;
                    $('#myTab1 a[href="#s1"]').tab('show');
                    $scope.campos_nao_editavel = true;
                    $scope.turnos = [];
                    $scope.getTurnos();
                    $scope.getPesquisas();
                    $scope.getFilas();
                    $scope.getChat($r.name, () => {
                        $scope.showChatPopup = true;
                        delete $r.load;
                    })
                    break;
                case 3:
                    $r.load = true;
                    $('#myTab1 a[href="#Whatss1"]').tab('show');
                    $scope.pop = {};
                    $scope.WhatsApi.Fone = undefined;
                    $scope.WhatsApi.qrCode = undefined;
                    $scope.WhatsApi.Msg = undefined;
                    $scope.campos_nao_editavel = true;
                    $scope.turnos = [];
                    $scope.getTurnos();
                    $scope.getPesquisas();
                    $scope.getFilas();
                    $scope.filasTransbordo = $scope.FilasWhats;
                    $scope.getWhats($r.name, (ret) => {
                        $scope.showWhatsPopup = true;
                        $scope.pop.cmdapi = true;
                        delete $r.load;
                        //if(ret.emailConfig && ret.emailConfig.x5api){
                        //    $scope.showWhatsApiPopup = true;
                        //}
                    })
                    break;
                case 4:
                    $r.load = true;
                    $('#myTab1 a[href="#Emails1"]').tab('show');
                    $scope.campos_nao_editavel = true;
                    $scope.turnos = [];
                    $scope.getPesquisas();
                    $scope.getEmail($r.name, () => {
                        $scope.showEmailPopup = true;
                        delete $r.load;
                    })
                    break;
                case 5:
                    $r.load = true;
                    $('#myTab1 a[href="#Whatss1"]').tab('show');
                    $scope.pop = {};
                    $scope.WhatsApi.Fone = undefined;
                    $scope.WhatsApi.qrCode = undefined;
                    $scope.WhatsApi.Msg = undefined;
                    $scope.campos_nao_editavel = true;
                    $scope.turnos = [];
                    $scope.getTurnos();
                    $scope.getPesquisas();
                    $scope.getFilas();
                    $scope.filasTransbordo = $scope.FilasZenvia;
                    $scope.getWhats($r.name, (ret) => {
                        $scope.showWhatsPopup = true;
                        delete $r.load;
                    })
                    break;
                case 6:
                    $r.load = true;
                    $('#myTab1 a[href="#Whatss1"]').tab('show');
                    $scope.pop = {};
                    $scope.WhatsApi.Fone = undefined;
                    $scope.WhatsApi.qrCode = undefined;
                    $scope.WhatsApi.Msg = undefined;
                    $scope.campos_nao_editavel = true;
                    $scope.turnos = [];
                    $scope.getTurnos();
                    $scope.getPesquisas();
                    $scope.getFilas();
                    $scope.filasTransbordo = $scope.FilasInfobip;
                    $scope.getWhats($r.name, (ret) => {
                        $scope.showWhatsPopup = true;
                        delete $r.load;
                    })
                    break;
                case 7:
                    $r.load = true;
                    $('#myTab1 a[href="#Whatss1"]').tab('show');
                    $scope.pop = {};
                    $scope.WhatsApi.Fone = undefined;
                    $scope.WhatsApi.qrCode = undefined;
                    $scope.WhatsApi.Msg = undefined;
                    $scope.campos_nao_editavel = true;
                    $scope.turnos = [];
                    $scope.getTurnos();
                    $scope.getPesquisas();
                    $scope.getFilas();
                    $scope.filasTransbordo = $scope.FilasGupshup;
                    $scope.getWhats($r.name, (ret) => {
                        $scope.showWhatsPopup = true;
                        delete $r.load;
                    })
                    break;
                case 8:
                    $r.load = true;
                    $('#myTab1 a[href="#Whatss1"]').tab('show');
                    $scope.pop = {};
                    $scope.WhatsApi.Fone = undefined;
                    $scope.WhatsApi.qrCode = undefined;
                    $scope.WhatsApi.Msg = undefined;
                    $scope.campos_nao_editavel = true;
                    $scope.turnos = [];
                    $scope.getTurnos();
                    $scope.getPesquisas();
                    $scope.getFilas();
                    $scope.getWhats($r.name, (ret) => {
                        $scope.showFacePopup = true;
                        delete $r.load;
                    })
                    break;
                default:
                    break;


            }
        };

        $scope.getTipo = function (id) {
            return tipos.filter(function (op) {
                return op.id === id;
            });
        };

        $scope.ShowChat = function () {
            $('#myTab1 a[href="#s1"]').tab('show');
            $scope.chat = {};
            $scope.turnos = [];
            $scope.getTurnos();
            $scope.getPesquisas();
            $scope.getFilas();
            $scope.chat.timeout = 0;
            $scope.chat.maxlen = 0;
            $scope.chat.announce_frequency = 5;
            $scope.chat.strategy = $scope.estrategias[4];
            $scope.chat.queue_type = 2;
            $scope.chat.reportholdtime = false;
            $scope.campos_nao_editavel = false;
            $scope.showTypesPopup = false;
            $scope.showChatPopup = true;
        };

        $scope.ShowEmail = function () {
            $('#myTab1 a[href="#Emails1"]').tab('show');
            $scope.pop = {};
            $scope.pop.emailConfig = {};
            $scope.pop.emailConfig.imap = {};
            $scope.pop.emailConfig.imap.box = 'INBOX';
            $scope.pop.emailConfig.smtp = {};
            $scope.pop.timeout = 15;
            $scope.pop.announce_frequency = 5;
            $scope.pop.strategy = $scope.estrategias[4];
            $scope.pop.queue_type = 4;
            $scope.pop.reportholdtime = false;
            $scope.campos_nao_editavel = false;

            $scope.getPesquisas();
            $scope.showTypesPopup = false;
            $scope.showEmailPopup = true;

            //console.log($scope.pop);
        };

        $scope.ShowWhats = function (type) {
            $('#myTab1 a[href="#Whatss1"]').tab('show');
            $scope.pop = {};

            $scope.turnos = [];
            $scope.getPesquisas();
            $scope.getTurnos();
            $scope.getFilas();
            $scope.pop.cmdapi = false;
            $scope.pop.timeout = 0;
            $scope.pop.maxlen = 0;
            $scope.pop.announce_frequency = 5;
            $scope.pop.strategy = $scope.estrategias[4];
            $scope.pop.queue_type = type ? type : 3;
            $scope.pop.reportholdtime = false;
            $scope.pop.preatendimento = {};

            $scope.campos_nao_editavel = false;
            $scope.showTypesPopup = false;
            $scope.showWhatsPopup = true;

        };

        $scope.ShowFace = function (type) {
            $('#myTab1 a[href="#Whatss1"]').tab('show');
            $scope.pop = {};

            $scope.turnos = [];
            $scope.getPesquisas();
            $scope.getTurnos();
            $scope.getFilas();
            $scope.pop.cmdapi = false;
            $scope.pop.timeout = 0;
            $scope.pop.maxlen = 0;
            $scope.pop.announce_frequency = 5;
            $scope.pop.strategy = $scope.estrategias[4];
            $scope.pop.queue_type = type ? type : 8;
            $scope.pop.reportholdtime = false;
            $scope.pop.preatendimento = {};

            $scope.campos_nao_editavel = false;
            $scope.showTypesPopup = false;
            $scope.showFacePopup = true;

        };

        $scope.ShowVideo = function (type) {
            $('#myTab1 a[href="#Whatss1"]').tab('show');
            $scope.pop = {};

            $scope.turnos = [];
            $scope.getPesquisas();
            $scope.getTurnos();
            $scope.getFilas();
            $scope.pop.cmdapi = false;
            $scope.pop.timeout = 0;
            $scope.pop.maxlen = 0;
            $scope.pop.announce_frequency = 5;
            $scope.pop.strategy = $scope.estrategias[4];
            $scope.pop.queue_type = type ? type : 8;
            $scope.pop.reportholdtime = false;
            $scope.pop.preatendimento = {};

            $scope.campos_nao_editavel = false;
            $scope.showTypesPopup = false;
            $scope.showVideoPopup = true;

        };

        $scope.SalvarChat = function (f1) {
            if (f1.$valid) {
                var chat = angular.copy($scope.chat);
                chat.strategy = chat.strategy ? chat.strategy.cmd : null;
                // Tratar respostas
                chat.RespostasAutomaticas = [];
                if (chat.respostaSemAgente) {
                    chat.RespostasAutomaticas.push({ fila: chat.name, idRespostaTipo: 1, texto: chat.respostaSemAgente });
                }
                if (chat.respostaEncerramento) {
                    chat.RespostasAutomaticas.push({ fila: chat.name, idRespostaTipo: 2, texto: chat.respostaEncerramento });
                }
                if (chat.respostaAnuncio) {
                    chat.RespostasAutomaticas.push({ fila: chat.name, idRespostaTipo: 3, texto: chat.respostaAnuncio });
                }
                if (chat.respostaBoasVindas) {
                    chat.RespostasAutomaticas.push({ fila: chat.name, idRespostaTipo: 4, texto: chat.respostaBoasVindas });
                }
                if (chat.respostaForaDeTurno) {
                    chat.RespostasAutomaticas.push({ fila: chat.name, idRespostaTipo: 5, texto: chat.respostaForaDeTurno });
                }
                if (chat.respostaPesquisa) {
                    chat.RespostasAutomaticas.push({ fila: chat.name, idRespostaTipo: 6, texto: chat.respostaPesquisa });
                }
                if (chat.respostaEncerramentoInatividade) {
                    chat.RespostasAutomaticas.push({ fila: chat.name, idRespostaTipo: 7, texto: chat.respostaEncerramentoInatividade });
                }
                if (chat.respostaTransferidoFila) {
                    chat.RespostasAutomaticas.push({ fila: chat.name, idRespostaTipo: 8, texto: chat.respostaTransferidoFila });
                }
                if (chat.respostaTransferidoAgente) {
                    chat.RespostasAutomaticas.push({ fila: chat.name, idRespostaTipo: 9, texto: chat.respostaTransferidoAgente });
                }

                if (chat.turnosAceitos) {
                    chat.turnos = [];
                    chat.turnosAceitos.forEach(turno => {
                        const tob = {
                            TurnoID: turno.id,
                            FilaID: chat.name
                        };

                        chat.turnos.push(tob);
                    });
                }

                if (chat.preatendimento) {
                    if (!chat.preatendimento.repetirMsgInicial) {
                        chat.preatendimento.repetirMsgInicial = false;
                    }
                    if (!chat.preatendimento.queueName) {
                        chat.preatendimento.queueName = chat.name;
                    }

                    if (chat.preatendimento.menu) {
                        chat.preatendimento.menu = chat.preatendimento.menu.map(op => ({ app: op.app, opcao: op.opcao, pars: op.pars, queueName: chat.name }));
                    }
                }

                if (!chat.preatendimento_ativo) {
                    chat.preatendimento = {};
                }
                delete chat.preatendimento_ativo;

                delete chat.respostaSemAgente;
                delete chat.respostaEncerramento;
                delete chat.respostaAnuncio;
                delete chat.respostaBoasVindas;
                delete chat.respostaForaDeTurno;
                delete chat.respostaPesquisa;
                delete chat.verifica_turno;
                delete chat.turnosAceitos;
                delete chat.respostaEncerramentoInatividade;
                delete chat.respostaTransferidoFila;
                delete chat.respostaTransferidoAgente;

                if (chat.id) {
                    delete chat.id;
                    $http.put(options.api.restv2 + "/fila/" + $scope.chat.name, chat).
                        success(function (data) {
                            $scope.showChatPopup = false;
                            $.smallBox({
                                title: "SUCESSO!!",
                                content: "<i class='fa fa-check'></i> <i>Fila " + chat.name + " atualizada!</i>",
                                color: "#739E73",
                                timeout: 2000
                            });
                            $scope.load();
                        });
                }
                else {
                    $http.post(options.api.restv2 + "/fila", chat).
                        success(function (data) {
                            $scope.showChatPopup = false;
                            $.smallBox({
                                title: "SUCESSO!!",
                                content: "<i class='fa fa-check'></i> <i>Fila " + chat.name + " criada!</i>",
                                color: "#739E73",
                                timeout: 2000
                            });
                            $scope.load();
                        });
                }
            }
        };

        $scope.SalvarEmail = function (f1) {
            //console.log($scope.pop);

            if (f1.$valid) {
                var pop = angular.copy($scope.pop);
                // Tratar respostas
                pop.RespostasAutomaticas = [];
                if (pop.respostaSemAgente) {
                    pop.RespostasAutomaticas.push({ fila: pop.name, idRespostaTipo: 1, texto: pop.respostaSemAgente });
                }
                if (pop.respostaEncerramento) {
                    pop.RespostasAutomaticas.push({ fila: pop.name, idRespostaTipo: 2, texto: pop.respostaEncerramento });
                }
                if (pop.respostaAnuncio) {
                    pop.RespostasAutomaticas.push({ fila: pop.name, idRespostaTipo: 3, texto: pop.respostaAnuncio });
                }
                if (pop.respostaBoasVindas) {
                    pop.RespostasAutomaticas.push({ fila: pop.name, idRespostaTipo: 4, texto: pop.respostaBoasVindas });
                }
                if (pop.respostaForaDeTurno) {
                    pop.RespostasAutomaticas.push({ fila: pop.name, idRespostaTipo: 5, texto: pop.respostaForaDeTurno });
                }
                if (pop.respostaPesquisa) {
                    pop.RespostasAutomaticas.push({ fila: pop.name, idRespostaTipo: 6, texto: pop.respostaPesquisa });
                }
                if (pop.respostaEncerramentoInatividade) {
                    pop.RespostasAutomaticas.push({ fila: pop.name, idRespostaTipo: 7, texto: pop.respostaEncerramentoInatividade });
                }
                if (pop.respostaTransferidoFila) {
                    pop.RespostasAutomaticas.push({ fila: pop.name, idRespostaTipo: 8, texto: pop.respostaTransferidoFila });
                }
                if (pop.respostaTransferidoAgente) {
                    pop.RespostasAutomaticas.push({ fila: pop.name, idRespostaTipo: 9, texto: pop.respostaTransferidoAgente });
                }

                if (pop.turnosAceitos) {
                    pop.turnos = [];
                    pop.turnosAceitos.forEach(turno => {
                        const tob = {
                            TurnoID: turno.id,
                            FilaID: pop.name
                        }
                        pop.turnos.push(tob);
                    });
                }

                delete pop.respostaSemAgente;
                delete pop.respostaEncerramento;
                delete pop.respostaAnuncio;
                delete pop.respostaBoasVindas;
                delete pop.respostaForaDeTurno;
                delete pop.respostaPesquisa;
                delete pop.verifica_turno;
                delete pop.turnosAceitos;
                delete pop.respostaEncerramentoInatividade;
                delete pop.respostaTransferidoFila;
                delete pop.respostaTransferidoAgente;

                if (pop.strategy) {
                    pop.strategy = pop.strategy.cmd;
                }
                if ($scope.pop.emailConfig && $scope.pop.emailConfig.imap && $scope.pop.emailConfig.imap.search && $scope.pop.emailConfig.imap.search.length > 0) {
                    pop.emailConfig.imap.search = [];
                    angular.forEach($scope.pop.emailConfig.imap.search, function (a) {
                        pop.emailConfig.imap.search.push(a.value);
                    });
                }
                if (pop.id) {
                    delete pop.id;
                    $http.put(options.api.restv2 + "/fila/" + $scope.pop.name, pop).
                        success(function (data) {
                            $scope.showEmailPopup = false;
                            $.smallBox({
                                title: "SUCESSO!!",
                                content: "<i class='fa fa-check'></i> <i>Fila " + pop.name + " atualizada!</i>",
                                color: "#739E73",
                                timeout: 2000
                            });
                            $scope.load();
                        });
                }
                else {
                    $http.post(options.api.restv2 + "/fila", pop).
                        success(function (data) {
                            $scope.showEmailPopup = false;
                            $.smallBox({
                                title: "SUCESSO!!",
                                content: "<i class='fa fa-check'></i> <i>Fila " + pop.name + " criada!</i>",
                                color: "#739E73",
                                timeout: 2000
                            });
                            $scope.load();
                        });
                }
            }
            else {
                $.smallBox({
                    title: "<i class='glyphicon glyphicon-remove'></i> " + $scope.getWord('ERRO'),
                    content: $scope.getWord("Existem campos obrigatórios não preenchidos ou preenchidos incorretamente, verifique os campos em todas as tabas e tente novamente.."),
                    color: "#C46A69",
                    icon: "fa fa-warning shake animated"
                });
            }
        };

        $scope.AddOpcao = () => {
            if (!$scope.pop.preatendimento) $scope.pop.preatendimento = {};
            if (!$scope.pop.preatendimento.menu) $scope.pop.preatendimento.menu = [];
            $scope.pop.preatendimento.menu.push({ app: 'Fila', opcao: '', pars: '' });
        };

        $scope.DelOpcao = (index) => {
            $scope.pop.preatendimento.menu.splice(index, 1);
        };

        $scope.AddOpcaoChat = () => {
            if (!$scope.chat.preatendimento) $scope.chat.preatendimento = {};
            if (!$scope.chat.preatendimento.menu) $scope.chat.preatendimento.menu = [];
            $scope.chat.preatendimento.menu.push({ app: 'Fila', opcao: '', pars: '' });
        };

        $scope.DelOpcaoChat = (index) => {
            $scope.chat.preatendimento.menu.splice(index, 1);
        };

        $scope.SalvarFace = (f1) => {
            if (f1.$valid) {
                $scope.SalvarOmni('showFacePopup');
            }
        }

        $scope.SalvarVideo = (f1) => {
            if (f1.$valid) {
                $scope.SalvarOmni('showVideoPopup');
            }
        }

        $scope.SalvarWhats = (f1) => {
            if (f1.$valid) {
                $scope.SalvarOmni('showWhatsPopup');
            }
        }

        $scope.SalvarOmni = function (modal) {
            var pop = JSON.parse(JSON.stringify($scope.pop));

            // Tratar respostas
            pop.RespostasAutomaticas = [];
            if (pop.respostaSemAgente) {
                pop.RespostasAutomaticas.push({ fila: pop.name, idRespostaTipo: 1, texto: pop.respostaSemAgente });
            }
            if (pop.respostaEncerramento) {
                pop.RespostasAutomaticas.push({ fila: pop.name, idRespostaTipo: 2, texto: pop.respostaEncerramento });
            }
            if (pop.respostaAnuncio) {
                pop.RespostasAutomaticas.push({ fila: pop.name, idRespostaTipo: 3, texto: pop.respostaAnuncio });
            }
            if (pop.respostaBoasVindas) {
                pop.RespostasAutomaticas.push({ fila: pop.name, idRespostaTipo: 4, texto: pop.respostaBoasVindas });
            }
            if (pop.respostaForaDeTurno) {
                pop.RespostasAutomaticas.push({ fila: pop.name, idRespostaTipo: 5, texto: pop.respostaForaDeTurno });
            }
            if (pop.respostaPesquisa) {
                pop.RespostasAutomaticas.push({ fila: pop.name, idRespostaTipo: 6, texto: pop.respostaPesquisa });
            }
            if (pop.respostaEncerramentoInatividade) {
                pop.RespostasAutomaticas.push({ fila: pop.name, idRespostaTipo: 7, texto: pop.respostaEncerramentoInatividade });
            }
            if (pop.respostaTransferidoFila) {
                pop.RespostasAutomaticas.push({ fila: pop.name, idRespostaTipo: 8, texto: pop.respostaTransferidoFila });
            }
            if (pop.respostaTransferidoAgente) {
                pop.RespostasAutomaticas.push({ fila: pop.name, idRespostaTipo: 9, texto: pop.respostaTransferidoAgente });
            }

            if (pop.turnosAceitos && pop.verifica_turno) {
                pop.turnos = [];
                pop.turnosAceitos.forEach(turno => {
                    const tob = {
                        TurnoID: turno.id,
                        FilaID: pop.name
                    }
                    pop.turnos.push(tob);
                });
            } else {
                pop.turnos = [];
            }

            delete pop.respostaSemAgente;
            delete pop.respostaEncerramento;
            delete pop.respostaAnuncio;
            delete pop.respostaBoasVindas;
            delete pop.respostaForaDeTurno;
            delete pop.respostaPesquisa;
            delete pop.verifica_turno;
            delete pop.turnosAceitos;
            delete pop.respostaEncerramentoInatividade;
            delete pop.respostaTransferidoFila;
            delete pop.respostaTransferidoAgente;
            delete pop.cmdapi;

            if (pop.preatendimento) {
                if (!pop.preatendimento.repetirMsgInicial) {
                    pop.preatendimento.repetirMsgInicial = false;
                }
                if (!pop.preatendimento.queueName) {
                    pop.preatendimento.queueName = pop.name;
                }

                if (pop.preatendimento.menu) {
                    pop.preatendimento.menu = pop.preatendimento.menu.map(op => ({ app: op.app, opcao: op.opcao, pars: op.pars, queueName: pop.name }));
                }
            }

            if (!pop.preatendimento_ativo) {
                pop.preatendimento = {};
            }
            delete pop.preatendimento_ativo;


            pop.strategy = pop.strategy.cmd;
            if (pop.id) {
                delete pop.id;
                $http.put(options.api.restv2 + "/fila/" + $scope.pop.name, pop).
                    success(function (data) {
                        $scope[modal] = false;
                        $.smallBox({
                            title: "SUCESSO!!",
                            content: "<i class='fa fa-check'></i> <i>Fila " + pop.name + " atualizada!</i>",
                            color: "#739E73",
                            timeout: 2000
                        });
                        $scope.load();
                    });
            }
            else {
                $http.post(options.api.restv2 + "/fila", pop).
                    success(function (data) {
                        $scope[modal] = false;
                        $.smallBox({
                            title: "SUCESSO!!",
                            content: "<i class='fa fa-check'></i> <i>Fila " + pop.name + " criada!</i>",
                            color: "#739E73",
                            timeout: 2000
                        });
                        $scope.load();
                    });
            }
        };

        $scope.getChat = function (id, call) {
            $http.get(options.api.restv2 + "/fila/" + id).
                success(function (data) {
                    $scope.chat = data;
                    if ($scope.chat.strategy) {
                        angular.forEach($scope.estrategias, function (e) {
                            if (e.cmd == $scope.chat.strategy) {
                                $scope.chat.strategy = e;
                                return;
                            }
                        });
                    }
                    if ($scope.chat.RespostasAutomaticas) {
                        $scope.chat.RespostasAutomaticas.find((r) => {
                            switch (r.idRespostaTipo) {
                                case 1:
                                    $scope.chat.respostaSemAgente = r.texto;
                                    break;
                                case 2:
                                    $scope.chat.respostaEncerramento = r.texto;
                                    break;
                                case 3:
                                    $scope.chat.respostaAnuncio = r.texto;
                                    break;
                                case 4:
                                    $scope.chat.respostaBoasVindas = r.texto;
                                    break;
                                case 5:
                                    $scope.chat.respostaForaDeTurno = r.texto;
                                    break;
                                case 6:
                                    $scope.chat.respostaPesquisa = r.texto;
                                    break;
                                case 7:
                                    $scope.chat.respostaEncerramentoInatividade = r.texto;
                                    break;
                                case 8:
                                    $scope.chat.respostaTransferidoFila = r.texto;
                                    break;
                                case 9:
                                    $scope.chat.respostaTransferidoAgente = r.texto;
                                    break;
                            }
                        });
                    }
                    if ($scope.chat.turnos && $scope.chat.turnos.length > 0) {
                        if (!$scope.chat.turnosAceitos) $scope.chat.turnosAceitos = [];
                        $scope.chat.verifica_turno = true;
                        $scope.chat.turnos.forEach(turno => {
                            $scope.chat.turnosAceitos.push(turno);
                        });
                    }

                    if ($scope.chat.preatendimento && $scope.chat.preatendimento.queueName) {
                        $scope.chat.preatendimento_ativo = true;
                    }

                    call();
                });
        };

        $scope.getWhats = function (id, call) {
            $http.get(options.api.restv2 + "/fila/" + id).
                success(function (data) {
                    $scope.pop = data;
                    if ($scope.pop.strategy) {
                        angular.forEach($scope.estrategias, function (e) {
                            if (e.cmd == $scope.pop.strategy) {
                                $scope.pop.strategy = e;
                                return;
                            }
                        });
                    }
                    if ($scope.pop.RespostasAutomaticas) {
                        $scope.pop.RespostasAutomaticas.find((r) => {
                            switch (r.idRespostaTipo) {
                                case 1:
                                    $scope.pop.respostaSemAgente = r.texto;
                                    break;
                                case 2:
                                    $scope.pop.respostaEncerramento = r.texto;
                                    break;
                                case 3:
                                    $scope.pop.respostaAnuncio = r.texto;
                                    break;
                                case 4:
                                    $scope.pop.respostaBoasVindas = r.texto;
                                    break;
                                case 5:
                                    $scope.pop.respostaForaDeTurno = r.texto;
                                    break;
                                case 6:
                                    $scope.pop.respostaPesquisa = r.texto;
                                    break;
                                case 7:
                                    $scope.pop.respostaEncerramentoInatividade = r.texto;
                                    break;
                                case 8:
                                    $scope.pop.respostaTransferidoFila = r.texto;
                                    break;
                                case 9:
                                    $scope.pop.respostaTransferidoAgente = r.texto;
                                    break;
                            }
                        });
                    }
                    if ($scope.pop.turnos && $scope.pop.turnos.length > 0) {
                        if (!$scope.pop.turnosAceitos) $scope.pop.turnosAceitos = [];
                        $scope.pop.verifica_turno = true;
                        $scope.pop.turnos.forEach(turno => {
                            delete turno.descricao;
                            $scope.pop.turnosAceitos.push(turno);
                        });
                        //console.log($scope.pop.turnosAceitos);
                    }

                    if ($scope.pop.emailConfig) $scope.pop.emailConfig = JSON.stringify($scope.pop.emailConfig);

                    if ($scope.pop.preatendimento && $scope.pop.preatendimento.queueName) {
                        $scope.pop.preatendimento_ativo = true;
                    }

                    call(data);
                });
        };

        $scope.getEmail = function (id, call) {
            $http.get(options.api.restv2 + "/fila/" + id).
                success(function (data) {
                    $scope.pop = data;
                    if ($scope.pop.strategy) {
                        angular.forEach($scope.estrategias, function (e) {
                            if (e.cmd == $scope.pop.strategy) {
                                $scope.pop.strategy = e;
                                return;
                            }
                        });
                    }
                    if ($scope.pop.RespostasAutomaticas) {
                        $scope.pop.RespostasAutomaticas.find((r) => {
                            switch (r.idRespostaTipo) {
                                case 1:
                                    $scope.pop.respostaSemAgente = r.texto;
                                    break;
                                case 2:
                                    $scope.pop.respostaEncerramento = r.texto;
                                    break;
                                case 3:
                                    $scope.pop.respostaAnuncio = r.texto;
                                    break;
                                case 4:
                                    $scope.pop.respostaBoasVindas = r.texto;
                                    break;
                                case 5:
                                    $scope.pop.respostaForaDeTurno = r.texto;
                                    break;
                                case 6:
                                    $scope.pop.respostaPesquisa = r.texto;
                                    break;
                                case 7:
                                    $scope.pop.respostaEncerramentoInatividade = r.texto;
                                    break;
                                case 8:
                                    $scope.pop.respostaTransferidoFila = r.texto;
                                    break;
                                case 9:
                                    $scope.pop.respostaTransferidoAgente = r.texto;
                                    break;
                            }
                        });
                    }
                    if ($scope.pop.emailConfig) {
                        if ($scope.pop.emailConfig.imap && $scope.pop.emailConfig.imap.search && $scope.pop.emailConfig.imap.search.length > 0) {
                            var search = angular.copy($scope.pop.emailConfig.imap.search);
                            $scope.pop.emailConfig.imap.search = [];
                            angular.forEach(search, function (s) {
                                angular.forEach($scope.email_flags, function (f) {
                                    if (s == f.value) {
                                        $scope.pop.emailConfig.imap.search.push(f);
                                    }
                                });
                            });
                        }
                    }
                    call();
                });
        };

        $scope.WhatsApi = {
            getStatus() {
                this.loadStatus = true;
                console.log(`Chamei getWhatsStatus`);
                WhatsApiService.emit('getWhatsStatus', { instanceID: $scope.pop.name }, (ret) => {
                    this.loadStatus = false;
                    this.Fone = undefined;
                    console.log('Retornou...')
                    console.log(ret);

                    if (ret.FoneCon && ret.WhatsNetCon && !ret.WhatsAlerta && !ret.qrCode) {
                        this.qrCode = undefined;
                        this.Msg = undefined;

                        this.Fone = {
                            conn: true,
                            bat: ret.FoneBateria,
                            plug: ret.FonePlug,
                            Me: ret.Me
                        };

                        if (ret.FoneBateria <= 15) this.Fone.batA = true;
                        else if (ret.FoneBateria > 15 && ret.FoneBateria < 30) this.Fone.batB = true;
                        else if (ret.FoneBateria > 30 && ret.FoneBateria < 45) this.Fone.batC = true;
                        else this.Fone.batD = true;
                        //console.log(this.Fone);

                        return;
                    }

                    if (!ret.qrCodeNeedRefresh && ret.qrCode) {
                        this.qrCode = ret.qrCode;
                        this.Msg = undefined;
                        return;
                    }
                    if (ret.qrCode) {
                        this.qrCode = ret.qrCode;
                        this.Msg = undefined;
                        return;
                    }

                    this.Msg = ret.data ? ret.data : ret.msg;


                    if (ret.WhatsAlerta) {
                        this.Msg = ret.WhatsAlerta;
                    }
                    this.qrCode = undefined;
                    if (!this.Msg) this.Msg = 'Instancia com problema, Reinicie.';
                })
            },
            start() {
                this.StartClick = true;
                this.qrCode = undefined;
                this.loadStart = true;
                this.Fone = undefined;
                WhatsApiService.emit('startInstance', { instanceID: $scope.pop.name }, (ret) => {
                    let erroInicia = ret.errorDetails.indexOf('duplicate')
                    if (erroInicia != -1) ret.errorDetails = 'Erro ao iniciar instância. Instância já ativa.'
                    if (ret.errorDetails) ret.msg = ret.errorDetails
                    this.loadStart = false;
                    //console.log('Retornou...')
                    //console.log(ret);
                    this.Msg = ret.data ? ret.data : ret.msg;
                })
            },
            reload() {
                this.qrCode = undefined;
                this.Fone = undefined;
                console.log('Enviando refreshQrRequest');
                WhatsApiService.emit('refreshQrRequest', { instanceID: $scope.pop.name }, (ret) => {
                    console.log('refreshQrRequest Retornou...')
                    console.log(ret);
                    this.Msg = ret.data ? ret.data : ret.msg;
                })
            },
            stop() {
                this.StartClick = false;
                this.qrCode = undefined;
                this.loadStop = true;
                this.Fone = undefined;
                WhatsApiService.emit('stopInstance', { instanceID: $scope.pop.name }, (ret) => {
                    this.loadStop = false;
                    //console.log('Retornou...')
                    //console.log(ret);
                    this.Msg = ret.data ? ret.data : ret.msg;
                })
            },
            refresh() {
                this.loadRefresh = true;
                this.Fone = undefined;
                this.stop();
                setTimeout(function () {
                    $scope.WhatsApi.start();
                    $scope.WhatsApi.loadRefresh = false;
                }, 3000);
            }
        };

        $scope.showTab = (tab) => {
            console.log(`Era para exibir a tab ${tab}`);
            //$(`#myTab1 a[href="#${tab}"]`).tab('show');
            //$(`#${tab}`).addClass("in active");
            $(`#${tab}`).attr("class", "tab-pane fade in active");
            console.log($(`#${tab}`))
        }

    });
});
