define(['modules/filas/module', 'summernote'], function (module) {

    'use strict';

    module.registerDirective('descricaoEditor', function () {
        return {
            restrict: 'A',
            require: "ngModel",
            link: function (scope, element, attrs, ngModel) {
                element.removeAttr('smart-summernote-editor data-smart-summernote-editor');
                
                var options = {
                    focus : true,
                    tabsize : 2
                };

                if(attrs.height){
                    options.height = attrs.height;
                }

                element.summernote(options);
                
                function read() {
                    ngModel.$setViewValue(element.html());
                }
                
                ngModel.$render = function() {
                    element.html(ngModel.$viewValue || "");
                };
                
                element.bind("blur keyup change", function() {
                    scope.$apply(read);
                });
            }
        }
    });
});