define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource',
    'ngTagsInput',
    'summernote',
    'summernote-pt-BR',
    'angular-summernote',
    'socket-io2',

    'ng-file-upload',
    'ui.bootstrap',
    'angularUtils.directives.dirPagination'

], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.filas', [
        'ui.router',
        'ngResource',
        'ngTagsInput',
        'summernote',

        'ngFileUpload',
        'ui.bootstrap',
        'angularUtils.directives.dirPagination'
    ]);


    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.filas', {
                url: '/filas',
                data: {
                    title: 'Filas',
                    permissions: {
                        only: ['app.filas']
                    }
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/filas/views/lista.html',
                        controller: 'FilasCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'layout/directives/editPopup',
                                'modules/filas/services/WhatsApi',
                                'modules/filas/directives/whatsPopup',
                                'modules/filas/directives/emailPopup',
                                'modules/filas/directives/chatPopup',
                                'modules/filas/directives/typesPopup',
                                'modules/filas/directives/filaPopup',
                                'modules/filas/controllers/FilasCtrl',
                                'modules/ui/directives/smartHtmlPopover'
                            ])
                        },
                    }
                }
            })

            .state('app.filas.editar', {
                url: '/editar/:id',
                data: {
                    title: 'Fila',
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/filas/views/form.html',
                        controller: 'FilasCtrl',
                        parent: 'app.filas',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/filas/controllers/FilasCtrl',
                                'modules/ui/directives/smartHtmlPopover',
                                'modules/filas/directives/filasFormValidate',
                                'modules/filas/directives/calculoPopup'
                            ])
                        }
                    }
                }
            })

            .state('app.filas.novo', {
                url: '/novo',
                data: {
                    title: 'Novo Fila',
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/filas/views/form.html',
                        controller: 'FilasCtrl',
                        parent: 'app.filas',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/filas/controllers/FilasCtrl',
                                'modules/ui/directives/smartHtmlPopover',
                                'modules/filas/directives/filasFormValidate'
                            ])
                        }
                    }
                }
            })

            .state('app.filas.ver', {
                url: '/ver/:id',
                data: {
                    title: 'Fila',
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/filas/views/form.html',
                        controller: 'FilasCtrl',
                        parent: 'app.filas',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/filas/controllers/FilasCtrl',
                                'modules/ui/directives/smartHtmlPopover',
                                'modules/filas/directives/filasFormValidate'
                            ])
                        }
                    }
                }
            })

            .state('app.filas.calculos', {
                url: '/calculos',
                data: {
                    title: 'Cálculos'
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/filas/views/lista.calculo.html',
                        controller: 'FilasCtrl',
                        parent: 'app.filas',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/filas/controllers/FilasCtrl',
                                'modules/ui/directives/smartHtmlPopover'
                            ])
                        }
                    }
                }
            })

            .state('app.filas.calculos_editar', {
                url: '/calculos_editar/:id',
                data: {
                    title: 'Cálculos'
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/filas/views/calculoform.html',
                        controller: 'FilasCtrl',
                        parent: 'app.filas',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/filas/controllers/FilasCtrl'
                            ])
                        }
                    }
                }
            })

            .state('app.filas.calculos_novo', {
                url: '/calculos_novo',
                data: {
                    title: 'Novo cálculo'
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/filas/views/calculoform.html',
                        controller: 'FilasCtrl',
                        parent: 'app.filas',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/filas/controllers/FilasCtrl'
                            ])
                        }
                    }
                }
            })

            .state('app.filas.performances', {
                url: '/performances',
                data: {
                    title: 'Cálculos de Performances'
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/filas/views/lista.performance.html',
                        controller: 'PerformanceCtrl',
                        parent: 'app.filas',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/filas/controllers/PerformanceCtrl',
                                'modules/ui/directives/smartHtmlPopover'
                            ])
                        }
                    }
                }
            })

            .state('app.filas.performance_novo', {
                url: '/performance_novo',
                data: {
                    title: 'Novo cálculo de Performance'
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/filas/views/form.performance.html',
                        controller: 'PerformanceCtrl',
                        parent: 'app.filas',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/filas/controllers/PerformanceCtrl'
                            ])
                        }
                    }
                }
            })

            .state('app.filas.performance_editar', {
                url: '/performance_editar/:id',
                data: {
                    title: 'Performance'
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/filas/views/form.performance.html',
                        controller: 'PerformanceCtrl',
                        parent: 'app.filas',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/filas/controllers/PerformanceCtrl'
                            ])
                        }
                    }
                }
            })

            .state('app.filas.grupos', {
                url: '/filas/grupos',
                data: {
                    title: 'Grupos'
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/filas/views/lista.grupos.html',
                        controller: 'FilaGruposCtrl',
                        parent: 'app.filas',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'layout/directives/editPopup',
                                'modules/filas/controllers/FilaGruposCtrl'
                            ])
                        }
                    }
                }
            })
    });

    module.run(function ($couchPotato, Permission, $localStorage, ModuloPermissao) {
        module.lazy = $couchPotato;
        Permission.defineRole('app.filas', function () {
            if (!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.filas", $localStorage.User.modulos)) {
                $localStorage.msg = {
                    tipo: "Erro",
                    txt: "Você não tem acesso ao relatório de filas."
                };
                return false;
            }
            else {
                return true;
            }
        });
    });

    return module;

});