define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource',
    'ngTagsInput',
    'underscore',
    'jspdf',
    'autotable',
    'doubleScrollBars'
], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.filasperformance', [
        'ui.router',
        'ngResource',
        'ngTagsInput',
        'doubleScrollBars'
    ]);

    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.filasperformance', {
                url: '/filasperformance',
                data: {
                    title: 'Performance de Filas',
                    permissions: {
                        only: ['app.filasperformance']
                    }
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/filasperformance/views/lista.html',
                        controller: 'FilasPerformanceCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/filasperformance/controllers/FilasPerformanceCtrl',
                                'modules/filasperformance/directives/filasPerformanceFormValidate',
                                'modules/ui/directives/smartProgressbar',
                                'modules/forms/directives/input/smartDatepicker',
                                'modules/forms/directives/input/smartTimepicker',
                                'modules/forms/directives/input/smartClockpicker'
                            ])
                        },
                    }
                }
            })
    });

    module.run(function ($couchPotato, Permission, $localStorage, ModuloPermissao) {
        module.lazy = $couchPotato;
        Permission.defineRole('app.filasperformance', function () {
            if (!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.filasperformance", $localStorage.User.modulos)) {
                $localStorage.msg = {
                    tipo: "Erro",
                    txt: "Você não tem acesso ao relatório de filas."
                };
                return false;
            }
            else {
                return true;
            }
        });
    });


    return module;

});
