define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource',
    'ngTagsInput',
    'underscore',
    'jspdf',
    'autotable',
    'moment',
    'multiple-date-picker'
], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.filasperformance_aesc', [
        'ui.router',
        'ngResource',
        'ngTagsInput',
        'multipleDatePicker'
    ]);

    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.filasperformance_aesc', {
                url: '/filasperformance_aesc',
                data: {
                    title: 'Performance de Filas',
                    permissions: {
                        only: ['app.filasperformance_aesc']
                    }
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/filasperformance_aesc/views/lista.html',
                        controller: 'filasperformance_aescCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/filasperformance_aesc/controllers/filasperformance_aescCtrl',
                                'modules/ui/directives/smartProgressbar',
                                'modules/forms/directives/input/smartDatepicker',
                                'modules/forms/directives/input/smartTimepicker',
                                'modules/forms/directives/input/smartClockpicker'
                            ])
                        },
                    }
                }
            })
    });

    module.run(function ($couchPotato, Permission, $localStorage, ModuloPermissao) {
        module.lazy = $couchPotato;
        Permission.defineRole('app.filasperformance_aesc', function () {
            if (!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.filasperformance_aesc", $localStorage.User.modulos)) {
                $localStorage.msg = {
                    tipo: "Erro",
                    txt: "Você não tem acesso ao relatório de filas."
                };
                return false;
            }
            else {
                return true;
            }
        });
    });


    return module;

});
