define(['modules/grupos/module'], function (module) {
    "use strict";

    return module.registerController('gruposCtrl', function ($scope, $http, $stateParams, $rootScope) {
        $scope.sortBy = 'nome';
        $scope.sortDescending = false;
        $scope.searchText = '';
        $scope.isNew = false;

        $scope.order = function (keyname, frist) {
            if (!frist) {
                $scope.sortBy = keyname;
                $scope.sortDescending = !$scope.sortDescending;
            }

            $scope.filteredRT.sort(function (a, b) {
                var sortBy = $scope.sortBy;
                if (a[sortBy] < b[sortBy]) {
                    return $scope.sortDescending ? 1 : -1;
                }
                if (a[sortBy] > b[sortBy]) {
                    return $scope.sortDescending ? -1 : 1;
                }
                return 0;
            });
        };

        $scope.getClass = function (coluna) {
            if ($scope.sortBy === coluna) {
                return $scope.sortDescending ? 'sorting_asc' : 'sorting_desc';
            }
            else {
                return 'sorting';
            }
        };

        $scope.filter = function () {
            $scope.filteredRT = JSON.parse(JSON.stringify($scope.reminderTypes));
            if ($scope.searchText && $scope.searchText.length > 0) {
                $scope.filteredRT = filterIt($scope.filteredRT, $scope.searchText);
            }
        };

        // Chamada para primeira pagina
        $scope.load = function () {
            $scope.carregando = true;
            $http.get(`${options.api.restv3}/grupo?max=-1`).
                success(function (data) {
                    if (data) {
                        $scope.reminderTypes = data.dados;
                        $scope.filteredRT = JSON.parse(JSON.stringify($scope.reminderTypes));
                        $scope.order(null, true);
                    }
                    $scope.carregando = false;
                });
        };

        $scope.novo = async () => {
            $scope.pop = {};
            $scope.showPopup = true;
        }

        $scope.editar = async (row) => {
            row.load = true;

            let t = await $http.get(`${options.api.restv3}/grupo/${row.id}`);
            $scope.pop = t.data.dados;

            row.load = false;
            $scope.showPopup = true;
        }

        $scope.Salvar = async (f) => {
            if (f.$valid) {
                let dados = JSON.parse(JSON.stringify($scope.pop));
                delete dados.id;
                delete dados.context;

                try {
                    if ($scope.pop.id) {
                        await $http.put(`${options.api.restv3}/grupo/${$scope.pop.id}`, dados);
                    }
                    else {
                        await $http.post(`${options.api.restv3}/grupo`, dados);
                    }

                    $scope.showPopup = false;
                    $.smallBox({
                        title: "SUCESSO!!",
                        content: "<i class='fa fa-check'></i> <i>Atualizado com sucesso!</i>",
                        color: "#739E73",
                        timeout: 3000
                    });
                    $scope.load();
                } catch (error) {
                    console.log(error);
                }
            }
        }

        $scope.confirma = function (row) {
            $.x5Box({
                title: "Remover <b>" + row.nome + "</b>?",
                content: "Tem certeza que quer remover " + row.nome + "? <p class='text-align-right'><a id='yes' href-void class='btn btn-danger btn-sm btncallback'>Apagar</a> <a id='no' href-void class='btn btn-primary btn-sm btncallback'>Cancelar</a></p>",
                color: "#C46A69",
                //timeout: 8000,
                icon: "fa fa-warning shake animated"
            }, function (ButtonPressed) {
                if (ButtonPressed === "Apagar") {
                    $scope.delete(row.id);
                }
            });
        };

        $scope.delete = function (id) {
            $http.delete(options.api.restv3 + "/grupo/" + id).
                success(function (s) {
                    $.smallBox({
                        title: "SUCESSO!!",
                        content: "<i class='fa fa-check'></i> <i>Grupo apagado com sucesso!</i>",
                        color: "#739E73",
                        timeout: 3000
                    });

                    $scope.load();
                })
        };
    });
});