define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource'

], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.grupos', [
        'ui.router',
        'ngResource'
    ]);


    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.grupos', {
                url: '/grupos',
                data: {
                    title: 'grupos',
                    permissions: {
                        only: ['app.grupos']
                    }
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/grupos/views/lista.html',
                        controller: 'gruposCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/grupos/controllers/gruposCtrl'
                            ])
                        },
                    }
                }
            })
    });

    module.run(function ($couchPotato, Permission, $localStorage, ModuloPermissao) {
        module.lazy = $couchPotato;
        Permission.defineRole('app.grupos', function () {
            if (!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.ramais", $localStorage.User.modulos)) {
                $localStorage.msg = {
                    tipo: "Erro",
                    txt: "Você não tem acesso ao módulo de grupos."
                };
                return false;
            }
            else {
                return true;
            }
        });
    });

    return module;

});