define(['modules/layouts/module'], function (module) {
  "use strict";

  return module.registerController('LayoutsCtl', function ($scope, $http, $stateParams, $rootScope) {
    $scope.row = {};
    $scope.filtro = {};
    $scope.order = [{ "campo": "nome", "ordem": "ASC" }];

    $scope.reservados = [
      { valor: 'nome', nome: 'Nome' },
      { valor: 'texto', nome: 'Texto da mensagem' },
      { valor: 'email', nome: 'Email' },
      { valor: 'facebookID', nome: 'Facebook' },
      { valor: 'isBusiness', nome: 'Tipo de pessoa' },
      { valor: 'variavelTemplate', nome: 'Variável de template' },
      { valor: 'documento', nome: 'Documento' },
      { valor: 'url', nome: 'URL Integração' },
      { valor: 'telefoneA', nome: 'Telefone 1' },
      { valor: 'telefoneB', nome: 'Telefone 2' },
      { valor: 'telefoneC', nome: 'Telefone 3' },
      { valor: 'telefoneD', nome: 'Telefone 4' },
      { valor: 'telefoneE', nome: 'Telefone 5' },
      { valor: 'telefoneF', nome: 'Telefone 6' },
      { valor: 'telefoneG', nome: 'Telefone 7' },
      { valor: 'telefoneH', nome: 'Telefone 8' },
      { valor: 'telefoneI', nome: 'Telefone 9' },
      { valor: 'telefoneJ', nome: 'Telefone 10' },
      { valor: 'telefoneL', nome: 'Telefone 11' },
      { valor: 'telefoneM', nome: 'Telefone 12' },
      { valor: 'telefoneN', nome: 'Telefone 13' },
      { valor: 'telefoneO', nome: 'Telefone 14' },
      { valor: 'telefoneP', nome: 'Telefone 15' },
      { valor: 'telefoneQ', nome: 'Telefone 16' },
      { valor: 'telefoneR', nome: 'Telefone 17' },
      { valor: 'telefoneS', nome: 'Telefone 18' },
      { valor: 'telefoneT', nome: 'Telefone 19' },
      { valor: 'telefoneU', nome: 'Telefone 20' }
    ];

    $scope.gotoPage = function (page) {
      $scope.filtro.page = { valor: page };
      $scope.load();
    };

    /**
     * Carrega dados da contato
     * @returns void
     */
    $scope.load = function () {
      var par = [];
      if ($scope.filtro) {
        angular.forEach($scope.filtro, function (v, k) {
          if (v) par.push(k + "=" + v.valor);
        });
      }
      var pars = "";
      if (par.length > 0) {
        pars = "&" + par.join("&");
        console.log(pars);
      }
      $http.get(options.api.restv2 + "/layouts?max=15&modulo=campanhas&order=" + encodeURI(JSON.stringify($scope.order)) + pars).
        success(function (data) {
          $scope.table = data;
        });
    };

    $scope.showedit = function (row) {
      $scope.layout = angular.copy(row);
      var order = [{ "campo": "posicao_csv", "ordem": "ASC" }];
      $http.get(options.api.restv2 + "/layout/" + $scope.layout.id + "/campos?max=-1&order=" + encodeURI(JSON.stringify(order))).
        success(function (data) {
          for (var i = 0; i < data.dados.length; ++i) {
            delete data.dados[i].id;
            delete data.dados[i].id_layout;
          }
          $scope.layout.campos = data.dados;
          $scope.showLayoutPopup = true;
        });
    };

    $scope.shownew = function () {
      $scope.layout = {};
      $scope.layout.delimitador = ";";
      $scope.layout.cabecalho = true;
      $scope.layout.campos = [];
      $scope.layout.campos.push({ nome: '', posicao_csv: '', xcontact: '' });
      $scope.showLayoutPopup = true;
    };

    $scope.Save = function (f1) {
      if (f1.$valid) {
        var layout = angular.copy($scope.layout);
        delete layout.campos;
        delete layout.id;
        if ($scope.layout.id) {
          $http.put(options.api.restv2 + "/layout/" + $scope.layout.id, layout).
            success(function (data) {
              // Se deu sucesso atualiza os campos
              if ($scope.layout.campos) {
                //var campos = angular.copy($scope.layout.campos);
                for (var i = 0; i < $scope.layout.campos.length; ++i) {
                  if (!$scope.layout.campos[i].xcontact) $scope.layout.campos[i].xcontact = null;
                }
                $http.put(options.api.restv2 + "/layout/" + $scope.layout.id + "/campos", $scope.layout.campos).
                  success(function (data) {
                    $scope.load();
                    $scope.showLayoutPopup = false;
                    $.smallBox({
                      title: $scope.getWord('SUCESSO') + "!!",
                      content: "<i class='fa fa-check'></i> <i>Layout atualizado com sucesso!</i>",
                      color: "#739E73",
                      timeout: 2000
                    });
                  });
              }
            });
        }
        else {
          $http.post(options.api.restv2 + "/layout", layout).
            success(function (data) {
              // Se deu sucesso atualiza os campos
              if ($scope.layout.campos) {
                //var campos = angular.copy($scope.layout.campos);
                for (var i = 0; i < $scope.layout.campos.length; ++i) {
                  if (!$scope.layout.campos[i].xcontact) $scope.layout.campos[i].xcontact = null;
                }
                $http.put(options.api.restv2 + "/layout/" + data.id + "/campos", $scope.layout.campos).
                  success(function (data) {
                    $scope.load();
                    $scope.showLayoutPopup = false;
                    $.smallBox({
                      title: $scope.getWord('SUCESSO') + "!!",
                      content: "<i class='fa fa-check'></i> <i>Layout atualizado com sucesso!</i>",
                      color: "#739E73",
                      timeout: 2000
                    });
                  });
              }
            });
        }
      }
      else {
        alert($scope.getWord('Existem campos obrigatórios não preenchidos.'));
        console.log(f1);
      }
    };

    $scope.$watch('Pesquisa', function (t1, t2) {
      // Se os dois valores estirem em branco nao faz nada, isso aconte no load.
      if (!t1 && !t2)
        return false;

      setTimeout(function () {
        if (t1 === $scope.Pesquisa) {
          if (t1 !== '') {
            $scope.filtro.nome = { valor: t1 };
          }
          else {
            delete $scope.filtro.nome;
          }
          $scope.load();
        }
      }, 1000);
    });

    $scope.confirma = function (row) {
      $.x5Box({
        title: "Remover <b>" + row.nome + "</b>?",
        content: "Tem certeza que quer remover " + row.nome + "? <p class='text-align-right'><a id='yes' href-void class='btn btn-danger btn-sm btncallback'>Apagar</a> <a id='no' href-void class='btn btn-primary btn-sm btncallback'>Cancelar</a></p>",
        color: "#C46A69",
        //timeout: 8000,
        icon: "fa fa-warning shake animated"
      }, function (ButtonPressed) {
        if (ButtonPressed === "Apagar") {
          $scope.delete(row.id);
        }
      });
    };

    $scope.delete = function (id) {
      $http.delete(options.api.restv2 + "/layout/" + id).
        success(function (s) {
          $.smallBox({
            title: "SUCESSO!!",
            content: "<i class='fa fa-check'></i> <i>Layout apagado com sucesso!</i>",
            color: "#739E73",
            timeout: 6000
          });

          $scope.load();
        })
    };

    $scope.AddItem = function () {
      $scope.layout.campos.push({ nome: '', posicao_csv: '', xcontact: '' });
    };

    $scope.DelItem = function (index) {
      $scope.layout.campos.splice(index, 1);
    }

    $scope.getClass = function (coluna) {
      if ($scope.order[0].campo === coluna) {
        return $scope.order[0].ordem === 'ASC' ? 'sorting_asc' : 'sorting_desc';
      }
      else {
        return 'sorting';
      }
    };

    $scope.setOrder = function (coluna) {
      if ($scope.order[0].campo === coluna) {
        $scope.order[0].ordem = $scope.order[0].ordem === 'ASC' ? 'DESC' : 'ASC';
      }
      else {
        $scope.order = [{ "campo": coluna, "ordem": "ASC" }];
      }
      //console.log($scope.order);
      $scope.load();
    };
  });
});
