define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource',
    'ng-file-upload'

], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.layouts', [
        'ui.router',
        'ngResource',
        'ngFileUpload'
    ]);


    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.layouts', {
                url: '/layouts',
                data: {
                    title: 'Layouts',
                    permissions: {
                        only: ['app.layouts']
                    }
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/layouts/views/lista.html',
                        controller: 'LayoutsCtl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/layouts/directives/layoutPopup',
                                'modules/layouts/controllers/LayoutsCtl'
                            ])
                        },
                    }
                }
            })
    });

    module.run(function ($couchPotato,Permission,ModuloPermissao,$localStorage,$rootScope) {
        module.lazy = $couchPotato;
        Permission.defineRole('app.layouts', function () {
            if(!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.layouts",$localStorage.User.modulos)){
               $localStorage.msg = {
                   tipo: "Erro",
                   txt: $rootScope.getWord("Você não tem acesso a Lista.")
               };
               return false;
            }
            else {
                return true;
            }
        });
    });

    return module;

});
