define(['modules/listas/module'], function(module){
    "use strict";

    return module.registerController('ContatoCtrl', function($scope, $http, $stateParams, $rootScope){        
        $scope.row = {};
        $scope.campos_disable = true;
        $scope.order = 'telefone1';
        $scope.order_sentido = 'ASC';
        
        $scope.lista = "";       
        
        if($stateParams.lista){
            $scope.row.id_lista = $stateParams.lista;
        }
        
        /**
         * Carrega dados para o FORM como combos, valores default etc...
         * @returns void
         */
        $scope.loadform = function() {
            // TODO
        };
        
        if($rootScope.$state.current.url.indexOf('ver') > 0){
            $scope.campos_disable = true;
        }
        
        $scope.CarregarItem = function(id){            
            $http.get(options.api.rest+"/lista_contato/"+id).
                success(function(data) {
                    $scope.row = data;
                    $scope.row.nomes = data.nomes.replace('{','').replace('}','').match(/("[^"]*")|[^,]+/g);
                    $scope.row.valores = data.valores.replace('{','').replace('}','').match(/("[^"]*")|[^,]+/g);
                    console.log($scope.row);
            });            
        };
        
        
        if($stateParams.id){
            $scope.CarregarItem($stateParams.id);            
        }
        
        $scope.gotoPage = function(page) {        
            //idxp = page.href.indexOf('page');
            //p = page.href.substr(idxp); 
            //var Atual = p[0].split('page=')[1] ? p[0].split('page=')[1] : 1;
            var Atual = page.href.split('page=')[1] ? page.href.split('page=')[1] : 1;
            
            var poso = page.href.indexOf('order');
            var pose = page.href.indexOf('&');
            if(poso >= 0){
                page.href = page.href.substring(0, poso)+'order[0]='+$scope.order+' '+$scope.order_sentido+page.href.substring(pose, page.href.length);
            }
            else {
                page.href+= '?order[0]='+$scope.order+' '+$scope.order_sentido;
            }

            $http.get(page.href).
                success(function(data) {
                    $scope.atual = Atual;
                    $rootScope.rows = data.itens;
                    $scope.rows = data.itens;
                    $scope.lista = $scope.rows[0].lista;
                    $scope.row.id_lista = $scope.rows[0].id_lista;
                    $scope.links = data.links;
                    $scope.total_items = data.total_items;
                    $scope.page_count = data.page_count;
                    $scope.page_size = data.page_size;
                    //console.log(data._embedded.plano);
                });
        };

        /**
         * Carrega dados da contato
         * @returns void
         */
        $scope.load = function() {            
            var ObPagina = {href: options.api.rest+"/lista_contatos/"+$stateParams.lista};
            $scope.gotoPage(ObPagina);
        };
        
        $scope.Editar = function() {
            $scope.campos_disable = true;
        };
        
        $scope.Cancelar_editar = function(){
            $scope.campos_disable = true;
        };

        $scope.Voltar = function(){
            $rootScope.$state.transitionTo('app.listas.contatos',{lista:$scope.row.id_lista});
            //$rootScope.$state.
        };
        
        $scope.$watch('Pesquisa', function(t1, t2){
            // Se os dois valores estirem em branco nao faz nada, isso aconte no load.
            if (!t1 && !t2)
                return false;

            setTimeout(function() {
                if (t1 === $scope.Pesquisa)
                {
                    var ObPagina;
                    if(t1 === '')
                       ObPagina = {href: options.api.rest+"/lista_contatos/"+$stateParams.lista};
                    else
                       ObPagina = {href: options.api.rest+"/listacontatos/"+t1};
                    
                    $scope.gotoPage(ObPagina);
                }
            }, 1000);
        });
        
        $scope.PorStatus = function() {            
            //console.log($scope.filtro.status);
            if($scope.filtro.status > 0)
                $scope.gotoPage({href: options.api.rest+"/contatosporstatus/"+$scope.filtro.status});
            else
                $scope.gotoPage({href: options.api.rest+"/contato"});
        };
        
        $scope.confirma =  function (row) {
            $.x5Box({
                title: "Remover <b>"+row.tefefone1+"</b>?",
                content: "Tem certeza que quer remover "+row.telefone1+"? <p class='text-align-right'><a id='yes' href-void class='btn btn-danger btn-sm btncallback'>Apagar</a> <a id='no' href-void class='btn btn-primary btn-sm btncallback'>Cancelar</a></p>",
                color: "#C46A69",
                //timeout: 8000,
                icon: "fa fa-warning shake animated"
            }, function (ButtonPressed) {
                if (ButtonPressed === "Apagar") {
                    $scope.delete(row.id);
                }
            });
        };
        
        $scope.delete = function(id) {        
            $http.delete(options.api.rest+"/lista_contato/"+id).
            success(function(s) {            
                $.smallBox({
                    title : "SUCESSO!!",
                    content : "<i class='fa fa-check'></i> <i>Contato apagada com sucesso!</i>",
                    color : "#739E73",
                    timeout : 6000
                });
                
                $scope.load();
            })
        };
        
        $scope.disca = function(numero) {        
            $http.get(options.api.rest+"/lista_contatos_disca_manual/teste/"+numero).
            success(function(s) {            
                $.smallBox({
                    title : "SUCESSO!!",
                    content : "<i class='fa fa-check'></i> <i>Discando!</i>",
                    color : "#739E73",
                    timeout : 6000
                });
            })
        };
        
        $scope.getClass = function(coluna){
            if($scope.order === coluna){
                return $scope.order_sentido === 'ASC' ? 'sorting_asc' : 'sorting_desc';
            }
            else {
                return 'sorting';
            }
        };
        
        $scope.setOrder = function(coluna){
            if($scope.order === coluna){
                $scope.order_sentido = $scope.order_sentido === 'ASC' ? 'DESC' : 'ASC';                
            }
            else {
                $scope.order = coluna;
                $scope.order_sentido = 'ASC';
            }
            $scope.gotoPage($scope.links.self);
        };
        
    });
});