define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource',
    'ng-file-upload',
    'ui.bootstrap',
    'highcharts',
    'highcharts-export',
    'angular-highcharts',
    'angularUtils.directives.dirPagination',
], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.mensagem_classificacoes', [
        'ui.router',
        'ngResource',
        'ngFileUpload',
        'ui.bootstrap',
        'highcharts-ng',
        'angularUtils.directives.dirPagination',
    ]);


    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.mensagem_classificacoes', {
                url: '/mensagem_classificacoes',
                data: {
                    title: 'Classificação de mensagens',
                    permissions: {
                        only: ['app.mensagem_classificacoes']
                    }
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/mensagem_classificacoes/views/lista.html',
                        controller: 'mensagem_classificacoesCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'layout/directives/editPopup',
                                'modules/mensagem_classificacoes/controllers/mensagem_classificacoesCtrl'
                            ])
                        },
                    }
                }
            })
    });

    module.run(function ($couchPotato, Permission, ModuloPermissao, $localStorage, $rootScope) {
        module.lazy = $couchPotato;
        Permission.defineRole('app.mensagem_classificacoes', function () {
            if (!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.mensagem_classificacoes", $localStorage.User.modulos)) {
                $localStorage.msg = {
                    tipo: "Erro",
                    txt: $rootScope.getWord("Você não tem acesso a mensagem_classificacoes.")
                };
                return false;
            }
            else {
                return true;
            }
        });
    });

    return module;

});