define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource'
], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.online', [
        'ui.router',
        'ngResource'
    ]);


    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.painelsupervisor.online', {
                url: '/painelsupervisor/online',
                data: {
                    title: 'Online',
                    permissions: {
                        only: ['app.painelsupervisor']
                    }
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/online/views/lista.html',
                        controller: 'onlineCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'util/util',
                                'modules/online/controllers/onlineCtrl',
                                'modules/forms/directives/input/smartTimepicker',
                                'modules/forms/directives/input/smartClockpicker'
                            ])
                        }
                    }
                }
            })
    });

    module.run(function ($couchPotato, Permission, $localStorage, ModuloPermissao) {
        module.lazy = $couchPotato;
        Permission.defineRole('app.painelsupervisor', function () {
            if (!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.painelsupervisor", $localStorage.User.modulos)) {
                $localStorage.msg = {
                    tipo: "Erro",
                    txt: "Você não tem acesso ao online."
                };
                return false;
            }
            else {
                return true;
            }
        });
    });

    return module;

});
