define(['modules/painelsupervisor/module', 'lodash', 'angular-highcharts'], function (module, _) {
    "use strict";

    module.registerController('ClassificacoesCtrl', function ($scope,$http,$filter,$localStorage) {
        
        $scope.data = [];
        $scope.series = [];
        
        $scope.type = 'Pie';
        
        $scope.options = {
                //Boolean - Nao preencher com cor as curvas
                datasetFill : false
        };

        $scope.onClick = function (points, evt) {
          console.log(points, evt);
        };
        
        
        $scope.getFilas = function() {
            $scope.filas = $localStorage.User.filas;
            $scope.filtro.fila = $scope.filas[0];
        };
        
        // Chamada para primeira pagina
        $scope.load = function() {       
            $scope.filas = [];
            $scope.agentes = [];
            $scope.filtro = {};

            //$scope.filtro.dataini = hoje.getDate();
            $scope.filtro.dataini = new Date();
            $scope.filtro.datafim = new Date();
            
            $scope.filtro.horaini = '00:00';
            $scope.filtro.horafim = '23:59';
            
            $scope.getFilas();
                        
            $scope.getGrafico();
        };
        
        $scope.getGrafico = function(){
            var filtros = angular.copy($scope.filtro);
            filtros.dataini = $filter('date')(filtros.dataini,'dd/MM/yyyy');
            filtros.datafim = $filter('date')(filtros.datafim,'dd/MM/yyyy');
            
            $scope.loading = true;
            $scope.entrantes = 0;
            $scope.saintes = 0;
            $scope.total_geral = 0;
            
           $http.post(options.api.rest+"/cdrfilas/getSumario",filtros).success(function(res){ 
                $scope.rows = res.entrantes;
                
                /**
                if($scope.rows.length > 0){ 
                    $scope.chartConfig.title = {
                        text: 'ENTRANTES - Fila <span style="text-transform: uppercase"><b>'+filtros.fila+'</b></span>'
                    };
                    
                    $scope.chartConfig.subtitle = {
                        text: 'De '+filtros.dataini+' '+$scope.filtro.horaini+' até '+filtros.datafim+' '+$scope.filtro.horafim
                    };
                    
                    $scope.chartConfig.series =  [
                        {
                            type: 'pie',
                            name: 'Total',
                            data: [
                                ['Atendidas',parseFloat(((parseInt($scope.rows[0].atendidas)/parseInt($scope.rows[0].total))*100).toFixed(2))],
                                ['Abandonadas',parseFloat(((parseInt($scope.rows[0].abandonadas)/parseInt($scope.rows[0].total))*100).toFixed(2))],
                                ['Diretas',parseFloat(((parseInt($scope.rows[0].direta)/parseInt($scope.rows[0].total))*100).toFixed(2))]
                            ]
                        }
                    ];
     
                    $scope.entrantes = parseInt($scope.rows[0].total)
                    $scope.total_geral += parseInt($scope.rows[0].total);
                }
                else {
                    $scope.chartConfig.series =  [];
                }
                **/
                
                $scope.loading = false;
            });
            
        };
      

        $scope.chartConfig = {
            chart: {
                type: 'column'
            },
            title: {
                text: 'World\'s largest cities per 2014'
            },
            subtitle: {
                text: 'Source: <a href="http://en.wikipedia.org/wiki/List_of_cities_proper_by_population">Wikipedia</a>'
            },
            xAxis: {
                type: 'category',
                labels: {
                    rotation: -45,
                    style: {
                        fontSize: '13px',
                        fontFamily: 'Verdana, sans-serif'
                    }
                }
            },
            yAxis: {
                min: 0,
                title: {
                    text: 'Population (millions)'
                }
            },
            legend: {
                enabled: false
            },
            tooltip: {
                pointFormat: 'Population in 2008: <b>{point.y:.1f} millions</b>'
            },
            series: [{
                name: 'Population',
                data: [
                    ['Shanghai', 23.7],
                    ['Lagos', 16.1],
                    ['Instanbul', 14.2],
                    ['Karachi', 14.0],
                    ['Mumbai', 12.5],
                    ['Moscow', 12.1],
                    ['São Paulo', 11.8],
                    ['Beijing', 11.7],
                    ['Guangzhou', 11.1],
                    ['Delhi', 11.1],
                    ['Shenzhen', 10.5],
                    ['Seoul', 10.4],
                    ['Jakarta', 10.0],
                    ['Kinshasa', 9.3],
                    ['Tianjin', 9.3],
                    ['Tokyo', 9.0],
                    ['Cairo', 8.9],
                    ['Dhaka', 8.9],
                    ['Mexico City', 8.9],
                    ['Lima', 8.9]
                ],
                dataLabels: {
                    enabled: true,
                    rotation: -90,
                    color: '#FFFFFF',
                    align: 'right',
                    format: '{point.y:.1f}', // one decimal
                    y: 10, // 10 pixels down from the top
                    style: {
                        fontSize: '13px',
                        fontFamily: 'Verdana, sans-serif'
                    }
                }
            }]
        };

    });
});
