define(['modules/painelsupervisor/module'], function(module){
    "use strict";

    module.registerController('OnlineCtrl', function($scope, Agente, Ligacao,$http,SocketService,$interval,$filter,$localStorage){
        if(SocketService.desconectado){
          console.log('Foi desconectado, reconectar');
          var io = require('socket-io');
          SocketService = io.connect(options.api.ws);
        }


        $scope.filas = [];
        $scope.filtro = {};
        $scope.janela = [];
        $scope.tentativa = 0;
        $scope.carregando = true;

        $scope.opcoes_naoatendidas = {barColor:'#ff021a',scaleColor:false,trackColor:'#e5e5e5',lineWidth:10,lineCap:'circle',size:125};
        $scope.opcoes_atendidas = {barColor:'#71843f',scaleColor:false,trackColor:'#e5e5e5',lineWidth:10,lineCap:'circle',size:125};

        /*
        Função de callback chamada pelo interval para incrementar o StatusTimer do agente.
        */
        $scope.InctimeAgente = function(agente) {
          //console.log('StatusTimer');
          agente.time++;
        };

        /*
        Função que processa o Clique no painel do agente para iniciar ou parar o timer do status.
        Inicia o timer de status quando o painel for aberto e para o timer quando painel for fechado.
        }
        */
        $scope.StatusTimer = function(agente,div){
          // Se true tava aberta cacela o relogio
          if($(div).attr('aria-expanded') == "true"){
            // Cancel
            if(agente.interval) {
              $interval.cancel(agente.interval);
              delete(agente.interval);
            }
          }
          else {
            if(!agente.interval){
              var moment = require('moment');
              var d1 = moment(agente.DataStatus);
              var d2 = moment();
              var duracao = moment.duration(d2.diff(d1));
              agente.time = parseInt(duracao.as('seconds'));
              agente.interval = $interval(function() {
                  $scope.InctimeAgente(agente);
              }, 1000);
            }
          }
        };

        $scope.TempoDecorrido = function (datast) {
            if(typeof v1 === undefined || typeof v2 === undefined) return 0;
            var moment = require('moment');
            var d1 = moment(datast);
            var d2 = moment();

            var duracao = moment.duration(d2.diff(d1));
            return duracao.get("hours");
            //var espera = espera.get("hours").toString().padStart(2, '0') +":"+ espera.get("minutes").toString().padStart(2, '0') +":"+ espera.get("seconds").toString().padStart(2, '0');
        };

        $scope.TimeAgo = function (ini) {            
            var moment = require('moment');
            return moment(ini).locale('pt-br').fromNow();
        };

        $scope.getPercentual = function (v1,v2) {
            if(typeof v1 === undefined || typeof v2 === undefined) return 0;
            v1 = parseInt(v1);
            v2 = parseInt(v2);
            if(v1 === 0) return 0;
            if(v2 === 0) return 100;
            return Math.round((v1/v2)*100);
        };

        $scope.getSoma = function (v1,v2) {
            if(typeof v1 === undefined || typeof v2 === undefined) return 0;
            return parseInt(v1)+parseInt(v2);
        };

        $scope.filterFilas = function (query) {
            var filas = $localStorage.User.filas;
            return filas.filter(function (f) {
                return f.toLowerCase().indexOf(query.toLowerCase()) != -1;
            });
        };

        $scope.getNome = function(nome){
            return nome;
        };

        SocketService.on('open', function () {
           $scope.tentativa = 0;
           console.log('Conexão com websocket aberta');
           var token = {token: "H91A+3zz_-.Y18DH1YeQP65l?G,Q7)F2agm|mq^ukdh,]k,Z[a@195uJhK3n-{"};
           SocketService.emit('authentication',JSON.stringify(token));
           //$scope.getQueueStatus(false);
           //if(timeout) $interval.cancel(timeout);
        });

        SocketService.on('authenticated', function () {
            console.log('Autenticou');
            $scope.getQueueStatus(false);
        });

        SocketService.on('disconnect', function (err) {
            console.log('### CONEXÃO FECHADA ###');
            $scope.filas = [];
            $scope.tentativa = 1;
            SocketService.desconectado = true;
            //timeout = $interval(Reconecta, 5000);
        });

        SocketService.on('connect_failed', function (err) {
            console.log('### FALHA NA CONEXAO, verifique se o serviço está rodando no servidor ###');
            $scope.filas = [];
            $scope.tentativa = 1;
        });

        SocketService.on('connect_error', function (err) {
            console.log('### FALHA NA CONEXAO, verifique se o serviço está rodando no servidor ###');
            $scope.filas = [];
            $scope.tentativa = 1;
        });

        function processaEventoRecebido(ev){
            var response = JSON.parse(ev);
            //console.log(response);
            switch (response.event) {
                case 'Pong':
                    Pong(response);
                break;
                case 'FilasStatus':
                    setQueueParams(response);
                break;
                case 'AgenteStatus':
                    AgenteStatus(response);
                break;
                case 'AgentePausa':
                    AgenteStatus(response);
                break;
                case 'AgenteAdicionado':
                    AgenteStatus(response);
                break;
                case 'AgenteRemovido':
                    removeAgente(response);
                break;
            }
        }

        function Pong(ret){
            console.log('PONG - Retorno do ping, alive = %s, qtdping = %s',ret.alive,qtdping);
            if(ret.alive) {
                qtdping = 0;
            }
        };

        SocketService.on('message', function (event) {
            processaEventoRecebido(event);
        });

        $scope.load = function(){
            $scope.filtro.filas = $localStorage.User.filas;
            $scope.getQueueStatus(false);
            //tmping = $interval(Ping, 20000);
        };

        $scope.setTipo = function(tipo,id) {
            $scope.janela[id] = tipo;
        };

        $scope.setPausa = function (motivo,agente) {
            var dados = {
                action: 'QueuePause',
                queue: agente.fila,
                stateinterface: agente.ramal,
                paused: true,
                motivo: motivo
            };
            SocketService.emit('message',JSON.stringify(dados));
        };

        $scope.setTiraPausa = function (agente) {
            var dados = {
                action: 'QueueUnpause',
                queue: agente.fila,
                interface: agente.ramal
            };
            SocketService.emit('message',JSON.stringify(dados));
        };

        $scope.setLogOff = function (agente) {
            var dados = {
                action: 'QueueRemove',
                queue: agente.fila,
                interface: agente.ramal
            };
            SocketService.emit('message',JSON.stringify(dados));
        };

        $scope.setLogOff2 = function (agente) {
            var dados = {
                action: 'QueueRemove',
                queue: agente.fila,
                interface: agente.ramal
            };
            SocketService.emit('message',JSON.stringify(dados));

            //$location.path('/logout');
        };

        $scope.setLogin = function (agente) {
            var dados = {
                action: 'QueueAdd',
                queue: agente.fila,
                interface: agente.ramal
            };
            SocketService.emit('message',JSON.stringify(dados));
        };

        $scope.setUnPause = function (agente) {
            var dados = {
                action: 'QueueUnpause',
                queue: agente.fila,
                interface: agente.ramal
            };
            SocketService.emit('message',JSON.stringify(dados));
        };

        $scope.reload = function(){
          $scope.filas = [];
          $scope.getQueueStatus(false);
        };

        $scope.getQueueStatus = function (fila) {
            var dados = {
                action: 'QueueStatus',
                queue: fila
            };
            SocketService.emit('message',JSON.stringify(dados));
        };

        $scope.getQueueSummary = function (fila){
            var dados = {
                action: 'QueueSummary',
                queue: fila
            };
            SocketService.emit('message',JSON.stringify(dados));
        };

        $scope.getLigacaoAgente = function(agente) {
            if(agente.ligacoes_ativas.length === 0) return;
            return agente.ligacoes_ativas[0];
        };

        function AddOrUpdateFila(fila) {
            var tem = false;
            for(var j=0;j<$scope.filas.length;j++){
                if($scope.filas[j].nome === fila.nome) {
                    tem = true;
                    var f = $scope.filas[j];
                    f.abandonadas = fila.abandonadas;
                    f.aguardando = fila.aguardando;
                    f.atendidas = fila.atendidas;
                    f.efetuadas = fila.efetuadas;
                    f.estrategia = fila.estrategia;
                    f.maximo = fila.maximo;
                    f.tma = fila.tma;
                    f.tmab = fila.tmab;
                    f.tme = fila.tme;
                    f.ligacoes = fila.ligacoes;
                    // Remova a linha acima e descomente as abaixo para não listar ligações locais no aguardando...
                    //f.ligacoes = [];
                    //angular.forEach(fila.ligacoes, function(lig){
                    //    if(lig.origem.length > 4) f.ligacoes.push(lig);
                    //});
                    angular.forEach(fila.agentes, function(agente){
                      AddOrUpdateAgente($scope.filas[j],agente);
                    });
                }
            }
            if(!tem){
                $scope.filas.push(fila);
            }
        }

        function setQueueParams(ev){
            if(ev.filas instanceof Array){
              angular.forEach(ev.filas, function(evfila){
                // Se a fila não está na lista de filas do usuário ignora
                if($localStorage.User.filas.indexOf(evfila.nome) === -1) return;
                AddOrUpdateFila(evfila);
              });
            }
            else {
              // Se a fila não está na lista de filas do usuário ignora
              if($localStorage.User.filas.indexOf(ev.filas.nome) === -1) return;
              AddOrUpdateFila(ev.filas);
            }
        }

        $scope.getAbandonadas = function (fila) {
            if(!fila) return;
            fila.abandonadas_lista = [];
            fila.loading_abandonadas = true;
            var filtro = {
                dataini: $filter('date')(new Date(),'dd/MM/yyyy'),
                datafim: $filter('date')(new Date(),'dd/MM/yyyy'),
                fila: fila.nome,
                max: 0,
                status: 'Abandonada'
            };

            $http.post(options.api.rest+"/cdrfilas/filter",filtro).
                success(function(data) {
                    fila.loading_abandonadas = false;
                    fila.abandonadas_lista = data;
                });
        };


        $scope.getAgenteClass = function(status) {
            switch (status) {
                case 0:
                    return 'bg-color-blueLight';
                    break;
                case 1:
                    return 'bg-color-green';
                    break;
                case 2:
                    return 'bg-color-red';
                    break;
                case 3:
                    return 'bg-color-red';
                    break;
                case 4:
                    return 'bg-color-blueLight';
                    break;
                case 5:
                    return 'bg-color-blueLight';
                    break;
                case 6:
                    return 'bg-color-orange';
                    break;
                case 7:
                    return 'bg-color-orange';
                    break;
                case 8:
                    return 'bg-color-yellow';
                    break;
                // Nao existe no asterisk, criado para o paused = 1
                case 10:
                    return 'bg-color-yellow';
                    break;
                default :
                    return 'bg-color-blueLight';
            }
        };

        /*
        Atualiza os dados de um agente quando vier evento de agente.
        */
        function AddOrUpdateAgente(fila,novoagente){
            var tem = false;
            angular.forEach(fila.agentes, function(agente){
                if(agente.nome === novoagente.nome){
                  tem = true;
                  if(agente.status !== novoagente.status) agente.time = 0;
                  agente.DataStatus = novoagente.DataStatus;
                  agente.StatusNome = novoagente.StatusNome;
                  agente.DataUltimaLigacao = novoagente.DataUltimaLigacao;
                  agente.ligacoes_ativas = novoagente.ligacoes_ativas;
                  agente.ligacoes = novoagente.ligacoes;
                  agente.AtendeuEm = novoagente.AtendeuEm;
                  agente.LigacaoAguardou = novoagente.LigacaoAguardou;
                  agente.LigacaoDuracao = novoagente.LigacaoDuracao;
                  agente.LigacaoFim = novoagente.LigacaoFim;
                  agente.atendeu = novoagente.atendeu;
                  agente.dump = novoagente.dump;
                  agente.efetuada = novoagente.efetuada;
                  agente.efetuada_agente_finalizou = novoagente.efetuada_agente_finalizou;
                  agente.efetuada_cliente_finalizou = novoagente.efetuada_cliente_finalizou;
                  agente.efetuada_naocompletou = novoagente.efetuada_naocompletou;
                  agente.finalizada = novoagente.finalizada;
                  agente.finalizou = novoagente.finalizou;
                  agente.naoatendeu = novoagente.naoatendeu;
                  agente.transferiu = novoagente.transferiu;
                  agente.motivo = novoagente.motivo;
                  agente.pausa = novoagente.pausa;
                  agente.pausa_motivo = novoagente.pausa_motivo;
                  agente.status = novoagente.status;
                }
            });
            if(!tem){
              fila.agentes.push(novoagente);
            }
        }

        /*
        Processa o evento agente status
        */
        function AgenteStatus(ev){
          angular.forEach($scope.filas, function(fila){
            if(fila.nome === ev.agente.fila){
              AddOrUpdateAgente(fila,ev.agente);
            }
          });
        }

        function removeAgente(a){
            var ag = a.agente;
            for(var i=0;i<$scope.filas.length;++i){
                if($scope.filas[i].nome === ag.fila){
                   for(var j=0;j<$scope.filas[i].agentes.length;j++){
                       if($scope.filas[i].agentes[j].ramal === ag.ramal) {
                         if($scope.filas[i].agentes[j].interval){
                           console.log('Agente removido com interval ativo, parando...');
                           $interval.cancel($scope.filas[i].agentes[j].interval);
                         }
                         $scope.filas[i].agentes.splice(j, 1);
                       }
                   }
                }
            }
        }

        $scope.getTotalOnline = function (fila){
            var total=0;
            for(var i=0;i<fila.agentes.length;i++){
                if(fila.agentes[i].status === 1) total++;
            }
            return total;
        };

        $scope.getTotalPausa = function (fila){
            var total=0;
            for(var i=0;i<fila.agentes.length;i++){
                if(fila.agentes[i].status === 10) total++;
            }
            return total;
        };

        $scope.getTotalOcupado = function (fila){
            var total=0;
            for(var i=0;i<fila.agentes.length;i++){
                if(fila.agentes[i].status === 2 || fila.agentes[i].status === 3) total++;
            }
            return total;
        };

        $scope.$on('$destroy',function(){
            console.log('Saiu do online...');
            angular.forEach($scope.filas, function(fila){
              angular.forEach(fila.agentes, function(agente){
                  if(agente.interval){
                    console.log('Interval ativo, parando...');
                    $interval.cancel(agente.interval);
                  }
              });
            });
            SocketService.disconnect();
        });

    });
});
