define(['modules/painelsupervisor/module', 'lodash'], function (module) {
    "use strict";
    module.registerFactory('Fila', function($interval){
        
        function Fila(nome) {
            this.nome = nome;
            this.agentes = [];
        };
        
        Fila.prototype = {
            getNome : function () {        
                return (this.nome); 
            }, 
            setNome : function (value) { 
                this.nome = value; 
            },
            getAguardando: function () { 
                return (this.aguardando); 
            },
            setAguardando: function (value) { 
                this.aguardando = value; 
            },
            getAtendidas: function () { 
                return this.atendidas; 
            },
            setAtendidas: function (value) { 
                this.atendidas = value; 
            },
            getAbandonadas: function () { 
                return (this.abandonadas); 
            }, 
            setAbandonadas: function (value) { 
                this.abandonadas = value; 
            },
            getTme: function () { 
                return (this.tme); 
            },
            setTme: function (value) { 
                this.tme = value; 
            },
            getTma: function () { 
                return (this.tma); 
            },
            setTma: function (value) { 
                this.tma = value; 
            }, 
            getMaximo: function () { 
                return (this.maximo); 
            },
            setMaximo: function (value) { 
                this.maximo = value; 
            },        
            getEstrategia: function () { 
                return (this.estrategia); 
            },
            setEstrategia: function (value) { 
                this.estrategia = value; 
            },        
            getNivelServico: function () { 
                return (this.nivelservico); 
            },
            setNivelServico: function (value) { 
                this.nivelservico = value; 
            },        
            getPeso: function () { 
                return (this.peso); 
            }, 
            setPeso: function (value) { 
                this.peso = value; 
            },
            getTemAguardando : function(){
                return this.aguardando > 0 ? 100 : 0;  
            },
            getTemAbandono : function(){
                return this.abandonadas > 0 ? 100 : 0;  
            },
            getTemAtendidas : function(){
                return this.atendidas > 0 ? 100 : 0;  
            },
            addOrUpdateAgente: function (agente) { 
                var tem = false;                
                for(var i=0;i<this.agentes.length;++i){
                    var ag = this.agentes[i];
                    if(ag.ramal === agente.ramal){
                        ag = agente;
                    }
                }
                if(!tem) {
                    agente.fila = this.nome;
                    $interval( agente.incTime, 1000 );
                    this.agentes.push(agente);
                } 
            },
            setStatusAgente: function (agente) {
                for(var i=0;i<this.agentes.length;++i){
                    if(this.agentes[i].ramal === agente.ramal){
                        var ag = this.agentes[i];
                        // Troca de status atualiza a data
                        if(ag.status !== agente.status) {
                            ag.datastatus = new Date();
                            ag.time = 0;
                        }
                        ag.status = agente.status;                        
                        if(agente.penalizacoes) ag.penalizacoes = agente.penalizacoes;
                        if(agente.motivo) ag.motivo = agente.motivo;
                        if(agente.ligacoes) ag.ligacoes = agente.ligacoes;
                        if(agente.ultimaligacao) ag.ultimaligacao = agente.ultimaligacao;
                    }
                }
            },
            removeAgente: function (agente) { 
                for(var i=0;i<this.agentes.length;++i){                
                    if(this.agentes[i].ramal === agente.ramal){
                        this.agentes.splice(i, 1);
                        break;
                    }
                } 
            },
            getAgentes: function () { 
                return this.agentes; 
            },
            getAgentePorNome: function (nome) { 
                for(var i=0;i<this.agentes.length;++i){
                    if(this.agentes[i].getNome() === nome) return (this.agentes[i]);
                    //if(typeof agentes[i] !== 'Agente'){
                   //}
                } 
            }
        };
        
        return Fila;
    });       
});