define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource'

], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.pausas', [
        'ui.router',
        'ngResource'
    ]);


    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.pausas', {
                url: '/pausas',                
                data: {
                    title: 'Pausas',
                    permissions: {
                        only: ['app.pausas']
                    }
                },                
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/pausas/views/lista.html',
                        controller: 'PausasCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/pausas/controllers/PausasCtrl'
                            ])
                        },                        
                    }
                }
            })
            
            .state('app.pausas.editar', {
                url: '/editar/:id',
                data: {
                    title: 'Pausa',
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/pausas/views/form.html',
                        controller: 'PausasCtrl',
                        parent: 'app.pausas',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/pausas/controllers/PausasCtrl',
                                'modules/pausas/directives/pausasFormValidate'
                            ])
                        }
                    }
                }
            })
            
            .state('app.pausas.novo', {
                url: '/novo',
                data: {
                    title: 'Nova Pausa',
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/pausas/views/form.html',
                        controller: 'PausasCtrl',
                        parent: 'app.pausas',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/pausas/controllers/PausasCtrl',
                                'modules/pausas/directives/pausasFormValidate'
                            ])
                        }
                    }
                }
            })
            
            .state('app.pausas.ver', {
                url: '/ver/:id',
                data: {
                    title: 'Pausa',
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/pausas/views/form.html',
                        controller: 'PausasCtrl',
                        parent: 'app.pausas',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/pausas/controllers/PausasCtrl',
                                'modules/pausas/directives/pausasFormValidate'
                            ])
                        }
                    }
                }
            })
    });

    module.run(function ($couchPotato,Permission,$localStorage,ModuloPermissao) {
        module.lazy = $couchPotato;        
        Permission.defineRole('app.pausas', function () {
            if(!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.pausas",$localStorage.User.modulos)){
               $localStorage.msg = {
                   tipo: "Erro",
                   txt: "Você não tem acesso ao módulo de Pausas."
               };               
               return false;
            }            
            else {                
                return true;         
            }
        });
    });

    return module;

});