define(['modules/pin/module'], function (module) {
    "use strict";

    return module.registerController('PinCtrl', function ($scope, $timeout, $http, $stateParams, $rootScope) {
        $scope.row = {};
        $scope.campos_disable = false;
        $scope.order = 'nome';
        $scope.order_sentido = 'ASC';

        if ($rootScope.$state.current.url.indexOf('ver') > 0) {
            $scope.campos_disable = true;
        }

        $scope.LoadGrupos = function () {
            $http.get(options.api.rest + "/pin_grupos?max=0&order[0]=nome").
                success(function (data) {
                    $scope.grupos = data;
                });
        }

        $scope.getGrupo = function (query) {
            var opcoes = $scope.grupos;
            return opcoes.filter(function (op) {
                return op.id_nome.toLowerCase().indexOf(query.toLowerCase()) !== -1;
            });
        };

        $scope.CarregarItem = function (id) {
            if (!id) return;

            $scope.loading = true;
            $http.get(options.api.rest + "/pin/" + id).
                success(function (data) {
                    $scope.row = data;
                    $scope.senhaantiga = $scope.row.senha;
                    $scope.loading = false;
                });
        };


        if ($stateParams.id) {
            $scope.CarregarItem($stateParams.id);
        }

        $scope.gotoPage = function (page) {
            var Atual = page.href.split('page=')[1] ? page.href.split('page=')[1] : 1
            var newParam = 'order[0]=' + $scope.order + ' ' + $scope.order_sentido

            // Verificar se já existe um parâmetro 'order[0]' na URL
            var poso = page.href.indexOf('order[0]=')
            var pose = page.href.indexOf('&', poso)
            if (poso >= 0) {
                // Substituir o valor existente pelo novo
                page.href = page.href.substring(0, poso) + newParam + page.href.substring(pose >= 0 ? pose : page.href.length)
            } else {
                // Se não existe 'order[0]' na URL, adicionar o novo parâmetro
                page.href += (page.href.indexOf('?') >= 0 ? '&' : '?') + newParam
            }

            // Extrair a parte da URL após '/pins'
            var startIndex = page.href.indexOf('/pins')
            if (startIndex >= 0) {
                page.href = page.href.substring(startIndex)
            }

            $http.get(options.api.rest + page.href)
                .success(function (data) {
                    $scope.atual = Atual
                    $rootScope.rows = data.itens
                    $scope.rows = data.itens
                    $scope.links = data.links
                    $scope.total_items = data.total_items
                    $scope.page_count = data.page_count
                    $scope.page_size = data.page_size
                })
        }

        // Chamada para primeira pagina
        $scope.load = function () {
            var ObPagina = { href: options.api.rest + "/pins" };
            $scope.gotoPage(ObPagina);
        };

        $scope.Editar = function () {
            $scope.campos_disable = false;
        };

        $scope.Cancelar_editar = function () {
            $scope.CarregarItem($stateParams.id);
            $scope.campos_disable = true;
        };

        $scope.Salvar = function () {
            if ($scope.form.$valid) {
                if ($scope.senhaantiga !== $scope.row.senha) {
                    $scope.row.mudasenha = true;
                }
                $http.post(options.api.rest + "/pin", $scope.row).
                    success(function (data) {
                        $.smallBox({
                            title: "SUCESSO!!",
                            content: "<i class='fa fa-check'></i> <i>Salvo com sucesso!</i>",
                            color: "#739E73",
                            timeout: 1000
                        });
                        $rootScope.$state.transitionTo('app.pin');
                    })
            }
        };

        $scope.Voltar = function () {
            $rootScope.$state.transitionTo('app.pin');
        };

        $scope.$watch('Pesquisa', function (t1, t2) {
            // Se os dois valores estirem em branco nao faz nada, isso aconte no load.
            if (!t1 && !t2)
                return false;

            setTimeout(function () {
                if (t1 === $scope.Pesquisa) {
                    var ObPagina;
                    if (t1 === '')
                        ObPagina = { href: options.api.rest + "/pins" };
                    else
                        ObPagina = { href: options.api.rest + "/pins/" + t1.toLowerCase() };

                    $scope.gotoPage(ObPagina);
                }
            }, 1000);
        });

        $scope.confirma = function (row) {
            $.x5Box({
                title: "Remover senha <b>" + row.nome + "</b>?",
                content: "Tem certeza que quer remover essa senha? <p class='text-align-right'><a id='yes' href-void class='btn btn-danger btn-sm btncallback'>Apagar</a> <a id='no' href-void class='btn btn-primary btn-sm btncallback'>Cancelar</a></p>",
                color: "#C46A69",
                //timeout: 8000,
                icon: "fa fa-warning shake animated"
            }, function (ButtonPressed) {
                if (ButtonPressed === "Apagar") {
                    $scope.delete(row.id);
                }
            });
        };

        $scope.delete = function (id) {
            $http.delete(options.api.rest + "/pin/" + id).
                success(function (s) {
                    $.smallBox({
                        title: "SUCESSO!!",
                        content: "<i class='fa fa-check'></i> <i>Pin apagada com sucesso!</i>",
                        color: "#739E73",
                        timeout: 3000
                    });

                    $scope.load();
                })
        };

        $scope.pin_inativa = function (id) {
            $http.delete(options.api.rest + "/pin_inativa/" + id).
                success(function (s) {
                    $.smallBox({
                        title: "SUCESSO!!",
                        content: "<i class='fa fa-check'></i> <i>Pin Inativado com sucesso!</i>",
                        color: "#739E73",
                        timeout: 2000
                    });

                    $scope.load();
                })
        };

        $scope.getClass = function (coluna) {
            if ($scope.order === coluna) {
                return $scope.order_sentido === 'ASC' ? 'sorting_asc' : 'sorting_desc';
            }
            else {
                return 'sorting';
            }
        };

        $scope.setOrder = function (coluna) {
            if ($scope.order === coluna) {
                $scope.order_sentido = $scope.order_sentido === 'ASC' ? 'DESC' : 'ASC';
            }
            else {
                $scope.order = coluna;
                $scope.order_sentido = 'ASC';
            }
            $scope.gotoPage($scope.links.self);
        };


    });
});