define(['modules/pin/module'], function(module){
    "use strict";

    return module.registerController('PinGruposCtrl', function($scope, $http, $stateParams, $rootScope,$state){        
        $scope.row = {};
        $scope.campos_disable = false;
        $scope.order = 'id';
        $scope.order_sentido = 'ASC';
        
        if($rootScope.$state.current.url.indexOf('ver') > 0){
            $scope.campos_disable = true;
        }
        
        if($rootScope.$state.current.url.indexOf('novo') > 0){
            
        }
        
        $scope.CarregarItem = function(id){
            if(!id) return;
            
            $scope.loading = true;
            $http.get(options.api.rest+"/pin_grupo/"+id).
                success(function(data) {                
                    $scope.row = data;
                    $scope.loading = false;
                });
        };
        
        $scope.LoadGrupo = function(){
            if($stateParams.id){
                $scope.CarregarItem($stateParams.id); 
            }
        }
        
        $scope.gotoPage = function(page) {        
            //idxp = page.href.indexOf('page');
            //p = page.href.substr(idxp); 
            //var Atual = p[0].split('page=')[1] ? p[0].split('page=')[1] : 1;
            var Atual = page.href.split('page=')[1] ? page.href.split('page=')[1] : 1;
            
            var poso = page.href.indexOf('order');
            var pose = page.href.indexOf('&');
            if(poso >= 0){
                page.href = page.href.substring(0, poso)+'order[0]='+$scope.order+' '+$scope.order_sentido+page.href.substring(pose, page.href.length);
            }
            else {
                page.href+= '?order[0]='+$scope.order+' '+$scope.order_sentido;
            }

            $http.get(page.href).
                success(function(data) {
                    $scope.atual = Atual;
                    $rootScope.rows = data.itens;
                    $scope.rows = data.itens;
                    $scope.links = data.links;
                    $scope.total_items = data.total_items;
                    $scope.page_count = data.page_count;
                    $scope.page_size = data.page_size;
                    //console.log(data._embedded.plano);
                });
        };

        // Chamada para primeira pagina
        $scope.load = function() {            
            var ObPagina = {href: options.api.rest+"/pin_grupos"};
            $scope.gotoPage(ObPagina);
        };
        
        $scope.Editar = function() {
            $scope.campos_disable = false;
        };
        
        $scope.Cancelar_editar = function(){
              $scope.CarregarItem($stateParams.id);
              $scope.campos_disable = true;
        };
        
        $scope.Salvar = function(){
            if ($scope.form.$valid) {
                $http.post(options.api.rest+"/pin_grupo",$scope.row).
                    success(function(data){			
                        $.smallBox({
                            title : "SUCESSO!!",
                            content : "<i class='fa fa-check'></i> <i>Salvo com sucesso!</i>",
                            color : "#739E73",
                            timeout : 1000
                        });
                        $rootScope.$state.transitionTo('app.pin.grupos');                                        
                    });
            }
        };
        
        $scope.Voltar = function(){
            $rootScope.$state.transitionTo('app.pin');                                                                               
        };
        
        $scope.$watch('Pesquisa', function(t1, t2){
            // Se os dois valores estirem em branco nao faz nada, isso aconte no load.
            if (!t1 && !t2)
                return false;

            setTimeout(function() {
                if (t1 === $scope.Pesquisa)
                {
                    var ObPagina;
                    if(t1 === '')
                       ObPagina = {href: options.api.rest+"/pin_grupos"};
                    else
                       ObPagina = {href: options.api.rest+"/pin_grupos/"+t1};
                    
                    $scope.gotoPage(ObPagina);
                }
            }, 1000);
        });
        
        $scope.confirma =  function (row) {
            $.x5Box({
                title: "Remover <b>"+row.nome+"</b>?",
                content: "Tem certeza que quer remover "+row.nome+"? <p class='text-align-right'><a id='yes' href-void class='btn btn-danger btn-sm btncallback'>Apagar</a> <a id='no' href-void class='btn btn-primary btn-sm btncallback'>Cancelar</a></p>",
                color: "#C46A69",
                //timeout: 8000,
                icon: "fa fa-warning shake animated"
            }, function (ButtonPressed) {
                if (ButtonPressed === "Apagar") {
                    $scope.delete(row.id);
                }
            });
        };
        
        $scope.delete = function(id) {        
            $http.delete(options.api.rest+"/pin_grupo/"+id).
            success(function(s) {            
                $.smallBox({
                    title : "SUCESSO!!",
                    content : "<i class='fa fa-check'></i> <i>PIN apagado com sucesso!</i>",
                    color : "#739E73",
                    timeout : 1000
                });
                
                $scope.load();
            })
        };
        
        $scope.getClass = function(coluna){
            if($scope.order === coluna){
                return $scope.order_sentido === 'ASC' ? 'sorting_asc' : 'sorting_desc';
            }
            else {
                return 'sorting';
            }
        };
        
        $scope.setOrder = function(coluna){
            if($scope.order === coluna){
                $scope.order_sentido = $scope.order_sentido === 'ASC' ? 'DESC' : 'ASC';                
            }
            else {
                $scope.order = coluna;
                $scope.order_sentido = 'ASC';
            }
            $scope.gotoPage($scope.links.self);
        };
        
        
    });
});