define(['modules/rotas/module', 'jquery-maskedinput', 'jquery-validation'], function (module) {

    'use strict';

    return module.registerDirective('showPopup', function () {
        return {
            restrict: 'E',
            replace: true,
            transclude: true,
            templateUrl: 'app/modules/rotas/views/rota.popup.html',
            scope: true,
            link: function postLink(scope, element, attrs) {
                scope.title = attrs.title;
                scope.$watch(attrs.visible, function(value){
                  if(value === true)
                    $(element).modal('show');
                  else
                    $(element).modal('hide');
                });

                $(element).on('shown.bs.modal', function(){
                  scope.$apply(function(){
                    scope.$parent[attrs.visible] = true;
                  });
                });

                $(element).on('hidden.bs.modal', function(){
                  scope.$apply(function(){
                    scope.$parent[attrs.visible] = false;
                  });
                });
            }
        };
    });
});
