define(['modules/sms/module'], function(module){
    "use strict";

    return module.registerController('CanaisCtrl', function($scope, $http, $stateParams, $rootScope){
        $scope.row = {};        
        $scope.campos_disable = false;
        $scope.campos_nao_editavel = false;
        $scope.order = 'canal';
        $scope.order_sentido = 'ASC';
        
        $scope.CarregaDependencias = function(){
            $http.get(options.api.rest+"/operadoras?max=0&order[0]=nome").
            success(function(data) {                
                $scope.operadoras = data.itens;                
            });
            
            $http.get(options.api.rest+"/canais_gsm_grupos?max=0&order[0]=nome").
            success(function(data) {                
                $scope.grupos = data.itens;                
            });
        }
        
        $scope.CarregarItem = function(id){
            if(!id) return;
            
            $scope.loading = true;
            $http.get(options.api.rest+"/canais_gsm/"+id).
                success(function(data) {                
                    $scope.row = data;
                    $scope.loading = false;
                });
        };             
        
        $scope.gotoPage = function(page) {        
            var Atual = page.href.split('page=')[1] ? page.href.split('page=')[1] : 1;
            
            var poso = page.href.indexOf('order');
            var pose = page.href.indexOf('&');
            if(poso >= 0){
                page.href = page.href.substring(0, poso)+'order[0]='+$scope.order+' '+$scope.order_sentido+page.href.substring(pose, page.href.length);
            }
            else {
                page.href+= '?order[0]='+$scope.order+' '+$scope.order_sentido;
            }
            $http.get(page.href).
                success(function(data) {
                    $scope.atual = Atual;
                    $rootScope.rows = data.itens;
                    $scope.rows = data.itens;
                    $scope.links = data.links;
                    $scope.total_items = data.total_items;
                    $scope.page_count = data.page_count;
                    $scope.page_size = data.page_size;
                });
        };

        // Chamada para primeira pagina
        $scope.load = function() {   
            var ObPagina = {href: options.api.rest+"/canais_gsms"};
            $scope.gotoPage(ObPagina);
        };
        
        $scope.Editar = function() {
            $scope.campos_disable = false;
            $scope.campos_nao_editavel = true;
        };
        
        $scope.Cancelar_editar = function(){
              $scope.CarregarItem($stateParams.id);              
              $scope.campos_disable = true;
              $scope.campos_nao_editavel = true;
        };        
        
        $scope.Salvar = function(){
            if ($scope.form1.$valid) {
                $http.post(options.api.rest+"/canais_gsm",$scope.row).
                    success(function(data){			
                        $.smallBox({
                            title : "SUCESSO!!",
                            content : "<i class='fa fa-check'></i> <i>Salvo com sucesso!</i>",
                            color : "#739E73",
                            timeout : 6000
                        });
                        $rootScope.$state.transitionTo('app.sms');                                        
                    })
            }
        };
        
        $scope.Voltar = function(){
            $rootScope.$state.transitionTo('app.sms');                                                                               
        };
        
        $scope.$watch('Pesquisa', function(t1, t2){
            // Se os dois valores estirem em branco nao faz nada, isso aconte no load.
            if (!t1 && !t2)
                return false;

            setTimeout(function() {
                if (t1 === $scope.Pesquisa)
                {
                    var ObPagina;
                    if(t1 === '')
                       ObPagina = {href: options.api.rest+"/canais_gsms"};
                    else
                       ObPagina = {href: options.api.rest+"/canais_gsms/"+t1};
                    
                    $scope.gotoPage(ObPagina);
                }
            }, 1000);
        });
        
        $scope.confirma =  function (row) {
            $.x5Box({
                title: "Remover <b>"+row.nome+"</b>?",
                content: "Tem certeza que quer remover "+row.nome+"? <p class='text-align-right'><a id='yes' href-void class='btn btn-danger btn-sm btncallback'>Apagar</a> <a id='no' href-void class='btn btn-primary btn-sm btncallback'>Cancelar</a></p>",
                color: "#C46A69",
                //timeout: 8000,
                icon: "fa fa-warning shake animated"
            }, function (ButtonPressed) {
                if (ButtonPressed === "Apagar") {
                    $scope.delete(row.id);
                }
            });
        };
        
        $scope.confirmalimpa =  function (row) {
            $.x5Box({
                title: "Zerar contatodor do canal <b>"+row.canal+"</b>?",
                content: "Esse procedimento zera o contador de envio/recebimento.<br>Tem certeza que quer zerar os contadores do canal "+row.canal+"? <p class='text-align-right'><a id='yes' href-void class='btn btn-info btn-sm btncallback'>Zerar</a> <a id='no' href-void class='btn btn-primary btn-sm btncallback'>Cancelar</a></p>",
                color: "#cfb527",
                //timeout: 8000,
                icon: "fa fa-warning shake animated"
            }, function (ButtonPressed) {
                if (ButtonPressed === "Zerar") {
                    $scope.zeracanal(row.id);
                }
            });
        };
        
        $scope.zeracanal = function(id) {        
            $http.delete(options.api.rest+"/canais_gsm_zera/"+id).
            success(function(s) {            
                $.smallBox({
                    title : "SUCESSO!!",
                    content : "<i class='fa fa-check'></i> <i>Zerado com sucesso!</i>",
                    color : "#739E73",
                    timeout : 3000
                });

                $scope.load();
            })
        };
        
        $scope.delete = function(id) {        
            $http.delete(options.api.rest+"/canais_gsm/"+id).
            success(function(s) {            
                $.smallBox({
                    title : "SUCESSO!!",
                    content : "<i class='fa fa-check'></i> <i>Apagado com sucesso!</i>",
                    color : "#739E73",
                    timeout : 6000
                });

                $scope.load();
            })
        };
        
        $scope.getClass = function(coluna){
            if($scope.order === coluna){
                return $scope.order_sentido === 'ASC' ? 'sorting_asc' : 'sorting_desc';
            }
            else {
                return 'sorting';
            }
        };
        
        $scope.setOrder = function(coluna){
            if($scope.order === coluna){
                $scope.order_sentido = $scope.order_sentido === 'ASC' ? 'DESC' : 'ASC';                
            }
            else {
                $scope.order = coluna;
                $scope.order_sentido = 'ASC';
            }
            $scope.gotoPage($scope.links.self);
        };
        
        $scope.sendpopup = function(row) {            
            $scope.pop = {};
            $scope.pop.canal = row.canal;         
            $scope.showModalSend = true;
            /**
            $http.get(options.api.rest+"/listasdisponiveis/"+$stateParams.id).
                success(function(data) {
                    $scope.listas = data;
                    $scope.showModalLista = true;
            });
            **/
        };
        
        $scope.enviar = function() {
            if ($scope.pop.numero && $scope.pop.msg) {
                $scope.enviandosms = true;
                $http.post(options.api.rest+"/sms/enviar",$scope.pop)
                    .success(function(data){			
                        console.log('Enviado com sucesso');
                        $.smallBox({
                            title : "SUCESSO!!",
                            content : "<i class='fa fa-check'></i> <i>Enviado com sucesso!</i>",
                            color : "#739E73",
                            timeout : 6000
                        });
                        $scope.enviandosms = false;
                        $scope.showModalSend = false;
                        //$rootScope.$state.transitionTo('app.sms');                                        
                    })
                    .error(function(data){			
                        console.log('Erro');
                        $scope.enviandosms = false;
                        $scope.showModalSend = false;
                        //$rootScope.$state.transitionTo('app.sms');                                        
                    })
            }
        };
    });
});