define(['modules/usuarios/module'], function(module){
    "use strict";
    return module.registerController('LogUserCtrl', function($scope, $http, $localStorage, $filter){
        $scope.carregando = false;
        $scope.filtro = {};
        $scope.table = [];
        $scope.order = [{"campo":"data_hora","ordem":"ASC"}];
        $scope.acoes = [
            {"valor":"V","nome": $scope.getWord('Vizualizou')},
            {"valor":"C","nome": $scope.getWord('Criou')},
            {"valor":"A","nome": $scope.getWord('Adicionou')},
            {"valor":"R","nome": $scope.getWord('Removeu')},
            {"valor":"U","nome": $scope.getWord('Atualizou')}
        ];

        $scope.getAcao = function(a) {
            var acao = $scope.acoes.find(item=>item.valor==a);
            return acao ? acao.nome : '';
        };

        $scope.load = function() {
            $scope.filtro.dataini = new Date();
            $scope.filtro.datafim = new Date();

            $scope.getUsuarios();
        };

        $scope.getUsuarios = function(){
            $http.get(options.api.rest+"/usuarios?max=0").
                success(function(data) {
                    $scope.usuarios = data.itens;                    
            });
        };

        $scope.filterUser = function (query) {            
            return $scope.usuarios.filter(function (f) {
                return f.fullname.toLowerCase().indexOf(query.toLowerCase()) != -1;
            });
        };

        $scope.filterAcao = function (query) {            
            return $scope.acoes.filter(function (f) {
                return f.nome.toLowerCase().indexOf(query.toLowerCase()) != -1;
            });
        };

        $scope.gotoPage = function(page) {
            $scope.filtro.page = page;
            $scope.getRel();
        };

        $scope.getRel = function(){
            $scope.carregando = true;
            var par = [];
            var filtros = angular.copy($scope.filtro);
            if($scope.filtro.horaini) delete filtros.horaini;
            if($scope.filtro.horafim) delete filtros.horafim;

            if($scope.filtro.dataini){
                delete filtros.dataini;
                if($scope.filtro.horaini){
                delete filtros.horaini;
                filtros.data_ini = $filter('date')($scope.filtro.dataini,'yyyy-MM-dd')+' '+$scope.filtro.horaini+':00';
                }
                else {
                filtros.data_ini = $filter('date')($scope.filtro.dataini,'yyyy-MM-dd')+' 00:00:00';
                }
            }
            if($scope.filtro.datafim){
                delete filtros.datafim;
                if($scope.filtro.horafim){
                delete filtros.horafim;
                filtros.data_fim = $filter('date')($scope.filtro.datafim,'yyyy-MM-dd')+' '+$scope.filtro.horafim+':00';
                }
                else {
                filtros.data_fim = $filter('date')($scope.filtro.datafim,'yyyy-MM-dd')+' 23:59:59';
                }
            }
            if(filtros.id_supervisor){
                for(var i=0;i<filtros.id_supervisor.length;++i){
                    filtros.id_supervisor[i] = filtros.id_supervisor[i].id;
                }
                filtros.id_supervisor = encodeURI(JSON.stringify(filtros.id_supervisor));
            }
            if(filtros.id_user){
                for(var i=0;i<filtros.id_user.length;++i){
                    filtros.id_user[i] = filtros.id_user[i].id;
                }
                filtros.id_user = encodeURI(JSON.stringify(filtros.id_user));
            }
            if(filtros.acao){
                for(var i=0;i<filtros.acao.length;++i){
                    filtros.acao[i] = filtros.acao[i].valor;
                }
                filtros.acao = encodeURI(JSON.stringify(filtros.acao));
            }

            if(filtros){
                angular.forEach(filtros, function(v, k) {
                    if(v) par.push(k+"="+v);
                });
            }
            var pars = "";
            if(par.length > 0){
                pars = "&"+par.join("&");
            }
            $http.get(options.api.restv2+"/usuarios/log?max=15&order="+encodeURI(JSON.stringify($scope.order))+pars).
                success(function(data) {
                    $scope.table = data;
                    $scope.carregando = false;
            });
        };

        $scope.getClass = function(coluna){
            if($scope.order[0].campo === coluna){
                return $scope.order[0].ordem === 'ASC' ? 'sorting_asc' : 'sorting_desc';
            }
            else {
                return 'sorting';
            }
        };

        $scope.setOrder = function(coluna){
            if($scope.order[0].campo === coluna){
                $scope.order[0].ordem = $scope.order[0].ordem === 'ASC' ? 'DESC' : 'ASC';
            }
            else {
              $scope.order = [{"campo":coluna,"ordem":"ASC"}];
            }
            $scope.getRel();
        };
    });
});