define(['modules/usuarios/module'], function (module) {
    "use strict";

    return module.registerController('UsuariosCtrl', function ($scope, $http, $stateParams, $rootScope, $localStorage, paginationService) {
        $scope.row = {};
        $scope.new_load = false;
        $scope.bt_deslogar_disabled = false;
        $scope.campos_disable = false;
        $scope.senhaantiga = "";

        $scope.sortBy = 'fullname';
        $scope.sortDescending = false;
        $scope.searchText = '';

        $scope.fontes_autenticacao = [];
        $scope.campo_senha = true;

        $scope.getCurPage = () => {
            return paginationService.getCurrentPage('pag');
        }

        $scope.getTotalPages = () => {
            return Math.ceil(paginationService.getCollectionLength('pag') / paginationService.getItemsPerPage('pag'))
        }

        $scope.getTotalItens = () => {
            return paginationService.getCollectionLength('pag');
        }

        $scope.order = function (keyname) {
            $scope.sortBy = keyname;
            $scope.sortDescending = !$scope.sortDescending;
            $scope.filter();
        };

        $scope.getClass = function (coluna) {
            if ($scope.sortBy === coluna) {
                return $scope.sortDescending ? 'sorting_asc' : 'sorting_desc';
            }
            else {
                return 'sorting';
            }
        };

        $scope.CarregarItem = function (id) {
            angular.forEach($rootScope.rows, function (r) {
                if (r.id == id) {
                    $scope.row = angular.copy(r);
                    $scope.senhaantiga = $scope.row.senha;
                    return;
                }
            });

            $http.get(options.api.rest + "/modulosusuario/" + id).
                success(function (data) {
                    $scope.modulos = data;
                    console.log(data);
                });
        };


        if ($stateParams.id) {
            $scope.CarregarItem($stateParams.id);
        }

        $scope.filter = function () {
            var results = $scope.filteredRT;
            results.length = 0;
            var searchText = $scope.searchText;
            var reminderTypes = $scope.reminderTypes;

            for (var i = 0; i < reminderTypes.length; ++i) {
                if (searchText.length > 0) {
                    if (reminderTypes[i].nome && reminderTypes[i].nome.toLowerCase().includes(searchText.toLowerCase())
                        || (reminderTypes[i].fullname && reminderTypes[i].fullname.toLowerCase().includes(searchText.toLowerCase()))) {
                        results.push(reminderTypes[i]);
                    }
                } else {
                    results.push(reminderTypes[i]);
                }
            }
            results.sort(function (a, b) {
                var sortBy = $scope.sortBy;
                if (a[sortBy] < b[sortBy]) {
                    return $scope.sortDescending ? 1 : -1;
                }
                if (a[sortBy] > b[sortBy]) {
                    return $scope.sortDescending ? -1 : 1;
                }
                return 0;
            });
        };

        // Chamada para primeira pagina
        $scope.load = function () {
            $scope.carregando = true;
            $http.get(`${options.api.restv4}/usuarios`).
                success(function (data) {
                    if (data) {
                        $scope.reminderTypes = data.map(item => {
                            item.fonte = item.autenticacao_fonte ? item.autenticacaoFontes[0].nome : 'Xcontact';
                            return item;
                        });
                        $scope.filteredRT = JSON.parse(JSON.stringify($scope.reminderTypes));
                        $scope.filter();
                    }
                    $scope.carregando = false;
                });
        };

        $scope.new = async () => {
            $scope.new_load = true;
            $scope.pop = {
                autenticacao_fonte: null,
                fullname: null,
                nome: null
            };
            const fontes = await $http.get(`${options.api.restv4}/autenticacao_fontes`);
            $scope.fontes_autenticacao = fontes.data ? fontes.data : [];
            $scope.new_load = false;

            $scope.showUsuarioPopup = true;
        }

        $scope.editar = async (ob) => {
            ob.loading = true;

            const fontes = await $http.get(`${options.api.restv4}/autenticacao_fontes`);
            $scope.fontes_autenticacao = fontes.data ? fontes.data : [];

            $http.get(`${options.api.restv3}/usuario/${ob.id}`).
                success(function (data) {
                    ob.loading = false;
                    $scope.showUsuarioPopup = true;
                    $scope.pop = data.dados;
                    $scope.senhaantiga = $scope.pop.senha;
                    $scope.FonteSelec();
                });
        };

        $scope.Deslogar = (ob) => {
            $scope.bt_deslogar_disabled = true;
            $http.put(`${options.api.restv4}/logoff/supervisor/${$scope.pop.id}`).
                success(function (data) {
                    $scope.bt_deslogar_disabled = false;
                    $.smallBox({
                        title: "SUCESSO!!",
                        content: "<i class='fa fa-check'></i> <i>Usuário deslogado com sucesso!</i>",
                        color: "#739E73",
                        timeout: 2000
                    });
                });
        };

        $scope.FonteSelec = () => {
            $scope.campo_senha = $scope.pop.autenticacao_fonte ? false : true;
        }

        $scope.Salvar = (f) => {
            if (f.$valid) {
                const pop = angular.copy($scope.pop);
                delete pop.status;

                if (pop.autenticacao_fonte && !pop.senha) {
                    pop.senha = '123456';
                }
                if (pop.senha == $scope.senhaantiga) {
                    console.log(`Não mudou a senha`);
                    delete pop.senha;
                }
                if (pop.id) {
                    delete pop.id;
                    delete pop.usa_grupo_fila;
                    $http.put(`${options.api.restv4}/usuario/${$scope.pop.id}`, pop)
                        .success(function (data) {
                            $scope.showUsuarioPopup = false;
                            $.smallBox({
                                title: "SUCESSO!!",
                                content: `<i class='fa fa-check'></i> <i>${$scope.getWord('Usuário')} ${pop.nome} ${$scope.getWord('atualizado com sucesso.')}</i>`,
                                color: "#739E73",
                                timeout: 2000
                            });

                            $scope.load();
                        });
                } else {
                    $http.post(`${options.api.restv4}/usuario`, $scope.pop)
                        .success(function (data) {
                            $scope.showUsuarioPopup = false;
                            $.smallBox({
                                title: "SUCESSO!!",
                                content: `<i class='fa fa-check'></i> <i>${$scope.getWord('Usuário')} ${pop.nome} ${$scope.getWord('criado com sucesso.')}</i>`,
                                color: "#739E73",
                                timeout: 2000
                            });

                            $scope.load();
                        });
                }
            }
        }

        $scope.Voltar = function () {
            $rootScope.$state.transitionTo('app.usuarios');
        };

        $scope.confirma = function (row) {
            $.x5Box({
                title: `${$scope.getWord('Remover')} <b>${row.nome}?</b>`,
                content: `${$scope.getWord('Tem certeza que quer remover')} ${row.nome} ? <p class='text-align-right'><a id='yes' href-void class='btn btn-danger btn-sm btncallback'>${$scope.getWord('Apagar')}</a> <a id='no' href-void class='btn btn-primary btn-sm btncallback'>${$scope.getWord('Cancelar')}</a></p>`,
                color: "#C46A69",
                //timeout: 8000,
                icon: "fa fa-warning shake animated"
            }, function (ButtonPressed) {
                if (ButtonPressed === "Apagar") {
                    $scope.delete(row.id);
                }
            });
        };

        $scope.delete = function (id) {
            $http.delete(`${options.api.restv4}/usuario/${id}`).
                success(function (s) {
                    $.smallBox({
                        title: "SUCESSO!!",
                        content: `<i class='fa fa-check'></i> <i>${$scope.getWord('Usuario apagado com sucesso')}</i>`,
                        color: "#739E73",
                        timeout: 4000
                    });

                    $scope.load();
                })
        };
    });
});