define(['modules/usuarios/module'], function (module) {
    "use strict";

    return module.registerController('UsuariosModulosCtrl', function ($scope, $http, $stateParams, $localStorage, $state) {
        $scope.selFilas = [];
        $scope.modulos = []

        $scope.setFila = function (f) {
            console.log(f);
            $scope.modulos.filas.pop(f);
        };

        $scope.onToggleGrupo = function () {
            $scope.filasuser.map(fila => { fila.tem = false })
            $scope.gruposuser.map(grupo => { grupo.tem = false })
        }

        $scope.init = async function () {
            let m = await $http.get(`${options.api.restv4}/modulos`);

            let u = await $http.get(`${options.api.restv4}/usuario/${$stateParams.id}/permicoes`);
            let umodulos = u.data;

            $scope.usa_grupo_fila = umodulos.usa_grupo_fila

            $scope.modulos = m.data.map(modulo => {
                modulo.modulos = modulo.modulos.map(sub => {
                    let per = umodulos.modulos.find(umo => umo.id_modulo == sub.id);
                    sub.tem = per ? true : false;
                    sub.extra_usuario = (per && per.extra_usuario) ? true : false;
                    if (sub.nome == 'app.log') {
                        if (per && per.extra_usuario) {
                            if (per.extra_usuario.includes('P')) sub.extra_payload = true;
                            if (per.extra_usuario.includes('Q')) sub.extra_query = true;
                            if (per.extra_usuario.includes('R')) sub.extra_parametro = true;
                            if (per.extra_usuario.includes('F')) sub.extra_retorno = true;
                        }
                    }
                    return sub;
                })
                return modulo;
            })

            let f = await $http.get(`${options.api.restv2}/filas?max=-1`);
            $scope.filasuser = f.data.dados.map(fila => {
                fila.tem = umodulos.filas.indexOf(fila.name) > -1 ? true : false;
                return fila;
            })

            const getGrupos = await $http.get(options.api.restv4 + "/gruposFilas?max=-1")
            $scope.gruposuser = getGrupos.data.dados.map(grupo => {
                grupo.tem = umodulos.grupos_fila.indexOf(grupo.nome) > -1 ? true : false
                return grupo
            })

            $scope.filasuser.sort(function (a, b) {
                if (a.name < b.name) {
                    return -1;
                }
                if (a.name > b.name) {
                    return 1;
                }
                return 0;
            });

        };

        $scope.Salvar = function () {
            let ret = [];
            //return console.log($scope.modulos);

            $scope.modulos.forEach(modulo => {
                let m = modulo.modulos.filter(mm => mm.tem);
                if (m && m.length > 0) ret.push({ id_modulo: modulo.id, extra_usuario: null });
                m.forEach(s => {
                    let permicao = { id_modulo: s.id, extra_usuario: s.extra_usuario ? 'G' : null };
                    if (s.nome == 'app.log') {
                        permicao.extra_usuario = '';
                        if (s.extra_payload) permicao.extra_usuario += 'P';
                        if (s.extra_query) permicao.extra_usuario += 'Q';
                        if (s.extra_parametro) permicao.extra_usuario += 'F';
                        if (s.extra_retorno) permicao.extra_usuario += 'R';
                    }
                    ret.push(permicao);
                });
            });

            const gruposFilter = $scope.usa_grupo_fila
                ? $scope.gruposuser.filter(g => g.tem).map(item => item.nome) : []

            const filasDosGrupos = $scope.gruposuser.filter(g => g.tem).flatMap(item => item.filas)

            const filasFilter = $scope.usa_grupo_fila
                ? [...new Set(filasDosGrupos)]
                : $scope.filasuser.filter(f => f.tem).map(item => item.name)

            var ob = {
                modulos: ret,
                usa_grupo_fila: $scope.usa_grupo_fila,
                grupos_fila: gruposFilter,
                filas: filasFilter,
            }

            $http.put(`${options.api.restv4}/usuario/${$stateParams.id}/permicoes`, ob).
                success(function (data) {
                    $.smallBox({
                        title: "SUCESSO!!",
                        content: "<i class='fa fa-check'></i> <i>Salvo com sucesso!</i>",
                        color: "#739E73",
                        timeout: 4000
                    });
                    $state.go('app.usuarios');
                })
        };
    });
});