define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource',
    'jspdf',
    'ngTagsInput',
    'autotable',
    'moment',
    'moment-br',
    'moment-timezone',
    'html2canvas',
    'html2pdf'
], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.webchat', [
        'ui.router',
        'ngResource',
        'ngTagsInput'
    ]);


    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.webchat', {
                url: '/webchat',
                data: {
                    title: 'Relatórios de mensagens Omnichannel',
                    permissions: {
                        only: ['app.webchat']
                    }
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/webchat/views/lista.html',
                        controller: 'webChatCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/webchat/directives/chatviewPopup',
                                'modules/webchat/directives/transferirPopup',
                                'layout/directives/editPopup',
                                'modules/webchat/controllers/webChatCtrl',
                                'modules/forms/directives/input/smartSelect2',
                                'modules/forms/directives/input/smartDatepicker',
                                'modules/forms/directives/input/smartTimepicker',
                                'modules/forms/directives/input/smartClockpicker'
                            ])
                        },
                    }
                }
            })
    });

    module.run(function ($couchPotato, Permission, $localStorage, ModuloPermissao) {
        module.lazy = $couchPotato;
        Permission.defineRole('app.webchat', function () {
            if (!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.webchat", $localStorage.User.modulos)) {
                $localStorage.msg = {
                    tipo: "Erro",
                    txt: "Você não tem acesso ao relatório de webchat."
                };
                return false;
            }
            else {
                return true;
            }
        });
    });


    return module;

});