define(['app'], function (app) {
    "use strict";
    app.service('clientSidePaginationService', function () {
        this.sortBy = '';
        this.dados = [];
        this.sortDescending = false;
        this.maxSize = 3; // Máximo de páginas exibidas no bloco de páginação
        this.currentPage = 1; // Página Atual
        this.numPerPage = 10; // Registros por página

        this.getClass = function (coluna) {
            if (this.sortBy === coluna) {
                return this.sortDescending ? 'sorting_asc' : 'sorting_desc';
            }
            else {
                return 'sorting';
            }
        };

        this.order = function (keyname) {
            if (keyname) {
                // Se eh a mesma coluna revert
                if (this.sortBy === keyname) {
                    this.sortDescending = !this.sortDescending;
                }
                else {
                    this.sortDescending = false;
                }
                this.sortBy = keyname;
            }
            let sortDescending = this.sortDescending;
            let sortBy = this.sortBy;


            this.dados.sort(function (a, b) {
                if (a[sortBy] < b[sortBy]) {
                    return sortDescending ? 1 : -1;
                }
                if (a[sortBy] > b[sortBy]) {
                    return sortDescending ? -1 : 1;
                }
                return 0;
            });

            this.totalItems = this.dados.length;
            this.numPages = Math.ceil(parseInt(this.totalItems) / this.numPerPage);
        };

        this.pagina = function () {
            if (!this.dados) return;

            var begin, end, index;
            begin = (this.currentPage - 1) * this.numPerPage;
            end = begin + this.numPerPage;
            //console.log(`Inicia em ${begin} e terminal em ${end}`);
            return this.dados.slice(begin, end);
            //index = $scope.pag.dados.indexOf(value);
            //return (begin <= index && index < end);
        };
    });
    return app;
});